<?php
namespace Litovchenko\AirTable\Model;

use TYPO3\CMS\Extbase\Object\ObjectManager;
use Litovchenko\AirTable\Utility\BaseUtility;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\SoftDeletes;

class Base extends Model
{	
    # protected $fillable = ['email', 'password']; // какие поля могут быть заполнены выполняя User::create()
	
	# protected $dates = ['created_at', 'deleted_at']; // какие поля будут типа Carbon
	
	# protected $appends = ['field1', 'field2']; // доп значения возвращаемые в JSON
	
	# protected $perPage = 25; // Да, вы можете переопределить число записей пагинации (по умолчанию 15)
	
	# use SoftDeletes;
	
	# protected $attributes = [
    #    'delayed' => false // The model's default values for attributes.
    # ];
	
    /**
     * @return string
     */
    public static function parameterClassLabel($class, $keyAnnotation, $value)
    {
		if($value == '--auto--'){
			$table = BaseUtility::getClassAnnotationValueNew($class, 'AirTable\Parameter\TableKey');
			if($GLOBALS['LANG']){
				return $GLOBALS['LANG']->sL($GLOBALS['TCA'][$table]['ctrl']['title']);
			} else {
				return $GLOBALS['TCA'][$table]['ctrl']['title'];
			}
		} else {
			return $value;
		}
    }
	
    /**
     * @return string
     */
    public static function parameterClassDescription($class, $keyAnnotation, $value)
    {
        return $value;
    }
	
    /**
     * @return string
     */
    #public static function parameterClassLiveSearchHashTagKey($class, $keyAnnotation, $value)
    #{
    #    return $value;
    #}
	
    /**
     * @return string
     */
    public static function parameterClassTableKey($class, $keyAnnotation, $value)
    {
        return $value;
    }
	
    /**
     * @return string
     */
    public static function parameterClassPidAny($class, $keyAnnotation, $value)
    {
        return $value;
    }
	
    /**
     * The "booting" method of the model.
	 * User::withoutGlobalScope('TestScope')->get();
	 * User::withoutGlobalScopes()->get();
     *
     * @return void
     */
    protected static function boot()
    {
        parent::boot();
		
		$r = new \ReflectionClass(get_called_class());
		$traits = $r->getTraits();
		if(count($traits)>0){
			foreach($traits as $k => $t){
				// Дополнительно реализацию условий смотреть: EXT: Improved overlays
				// http://www.typo3-tesseract.com/fileadmin/user_upload/documents/manuals/english/overlays.pdf
				if(method_exists($t->name,'bootScope'.end(explode('\\',$t->name)))){
					$table = BaseUtility::getTableNameFromClass(get_called_class());
					$trait = $t->name;
					$method = 'bootScope'.end(explode('\\',$t->name));
					static::addGlobalScope('bootScope_'.$t->name, function (Builder $queryBuilder) use ($trait, $method, $table) {
						$trait::$method($queryBuilder, $table);
					});
				}
			}
		}
		
		# static::updating(function($model)
        # {
        #   // выполнить какую-нибудь логику
        #    // переопределить какое-нибудь свойство, например $model->something = transform($something);
        # });
		
		# self::creating(function ($model) {
		#	  $model->uuid = (string)Uuid::generate();
		# });
    }
	
	/**
	 * Автоматизированная выборка связей (если не создана функция)
	*/
    public function __call($name, $arguments)
	{
		// linkApproach
		if(preg_match('/^getDefaultRelation_(.*?)_Method$/is',$name,$matchField) 
			|| preg_match('/^(.*?)_Data$/is',$name,$matchField)
				|| preg_match('/^(.*?)_Method$/is',$name,$matchField)
					|| preg_match('/^(.*?)#Method$/is',$name,$matchField)
						|| preg_match('/^(.*?)@Method$/is',$name,$matchField)
		){
			$field = $matchField[1];
			return $this->linkApproach($field);
		}
		
		return parent::__call($name, $arguments);
	}
	
	// Автоматизированная выборка связей 
	public function linkApproach($field)
	{
		$class = get_called_class(); 
		$annotationRelationType = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field');
		$classField = 'Litovchenko\AirTable\Field\\'.$annotationRelationType;
		return $classField::linkApproach($this,$class,$field);
	}
	
	// Создание связей
	public static function linkCreate($field, $idOne = null, $idTwo = null, $data = [])
	{
		$class = get_called_class();
		$modelFind = static::where('uid','=',$idOne)->first();
		if($modelFind){
			$fieldWithoutMethod = preg_replace('/_Method$/is','',$field);
			$annotationRelationType = BaseUtility::getClassFieldAnnotationValueNew($class,$fieldWithoutMethod,'AirTable\Field');
			$classField = 'Litovchenko\AirTable\Field\\'.$annotationRelationType;
			return $classField::linkCreate($modelFind,$class,$field,$idTwo,$data);
		} else {
			return false;
		}
	}
	
	// Удаление связей
	public function linkRemove($field, $idOne = null, $idTwo = null, $data = [])
	{
		$class = get_called_class();
		$modelFind = static::where('uid','=',$idOne)->first();
		if($modelFind){
			$fieldWithoutMethod = preg_replace('/_Method$/is','',$field);
			$annotationRelationType = BaseUtility::getClassFieldAnnotationValueNew($class,$fieldWithoutMethod,'AirTable\Field');
			$classField = 'Litovchenko\AirTable\Field\\'.$annotationRelationType;
			return $classField::linkRemove($modelFind,$class,$field,$idTwo,$data);
		} else {
			return false;
		}
	}
	
	// Список коллекций Uid Todo
	public function linkCollection($field, $id)
	{
		#$modelFind = static::getModel()->find($id);
		#foreach($modelFind as $k => $v){
		#	print $v->title;
		#}
		//getRelatedIds
		#print $modelFind[0]->title; 
		#print 1;
		#exit();
	}
	
	// Есть ли связь?
	public function linkHas($field, $idOne = null, $data = [])
	{
	}
	
	/**
	* Переопределение массива настроек таблицы
	* @configuration (TCA array)
	* @return array
	*/
    public static function postBuildConfiguration(&$configuration = [])
    {
	}
	
}