<?php
namespace Litovchenko\AirTable\Model;

use TYPO3\CMS\Extbase\Object\ObjectManager;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\SoftDeletes;
use Litovchenko\AirTable\Utility\BaseUtility;

class BaseCrud extends \Litovchenko\AirTable\Model\Base
{
	// use \Litovchenko\AirTable\Model\Traits\TraitGetAttribute;
	use \Litovchenko\AirTable\Model\Traits\TraitGetTable;
	use \Litovchenko\AirTable\Model\Traits\TraitUidPid;
	use \Litovchenko\AirTable\Model\Traits\TraitBootScopeDeleted;
	
	protected $primaryKey = 'uid';
	
	protected $dateFormat = 'U';

	public $timestamps = false;
	
	/**
	* Типы записей по умолчанию
	* @return array
	*/
    public static function baseRTypes()
    {
		return [
			0 => 'Тип по умолчанию'
		];
	}
	
	/**
	* Табы по умолчанию
	* @return array
	*/
    public static function baseTabs()
    {
		return [
			'main' => 'Основное',
			'access' => 'Доступ',
			'preview' => 'Анонс',
			'detail' => 'Подробно',
			'content' => 'Содержимое',
			'files' => 'Файлы',
			'props' => 'Свойства (###COUNT###)',
			'rels' => 'Связи (###COUNT###)',
			'cat' => 'Категоризация',
			'extended' => 'Расширенное',
		];
	}
}