<?php
namespace Litovchenko\AirTable\Model;

/**
 * @AirTable:<Table>
 * @AirTable\Parameter\Label:<Маркер>
 * @AirTable\Parameter\Description:<Текстовый блок, фрагмент, набор файлов>
 * @AirTable\Parameter\PidAny:<1>
 */

class Marker extends \Litovchenko\AirTable\Model\BaseCrud
{
	use \Litovchenko\AirTable\Field\Traits\RType;
	use \Litovchenko\AirTable\Field\Traits\Title;
	use \Litovchenko\AirTable\Field\Traits\Deleted;
	use \Litovchenko\AirTable\Field\Traits\ServiceNote;
	use \Litovchenko\AirTable\Field\Traits\BeUserId;
	
	/**
	* Типы записей по умолчанию
	* @return array
	*/
    public static function baseRTypes()
    {
		return [
			'--div1--' => 'Текстовые',
				'string' => 'Строка',
				'text' => 'Текст',
				'text_rte' => 'Текст (с редактором)',
				'link' => 'Ссылка',
			'--div2--' => 'Контент',
				'tt_content_one' => 'Элемент контента',
				'tt_content_many' => 'Элементы контента',
			'--div3--' => 'Файлы',
				'image1' => 'Изображение',
				'images' => 'Изображения',
				'file1' => 'Файл',
				'files' => 'Файлы',
			'--div4--' => 'Код',
				'code_html' => 'Html-код',
				'code_ts' => 'Typoscript-код',
			'--div5--' => 'Другое',
				'inline' => 'Inline вариант (Beta)',
				'flexform' => 'Гибкие параметры (Beta)',
				'teaser' => 'Набор полей (Beta)',
		];
	}
	
	/**
	 * @AirTable\Field:<Input>
	 * @AirTable\Field\Parameter\Position\string:<props,0>
	 * @AirTable\Field\Parameter\Label:<Содержимое (однострочное)>
	 */
	protected $string;

	/**
	 * @AirTable\Field:<Text>
	 * @AirTable\Field\Parameter\Position\text:<props,0>
	 * @AirTable\Field\Parameter\Label:<Содержимое (многострочное)>
	 */
	protected $text;

	/**
	 * @AirTable\Field:<TextRte>
	 * @AirTable\Field\Parameter\Position\text_rte:<props,0>
	 * @AirTable\Field\Parameter\Label:<Визуальный редактор>
	 */
	protected $text_rte;
	
	/**
	 * @AirTable\Field:<InputLink>
	 * @AirTable\Field\Parameter\Position\link:<props,0>
	 * @AirTable\Field\Parameter\Label:<Ссылка>
	 */
	protected $link;

	/**
	 * @AirTable\Field:<Rel_Poly_1to1>
	 * @AirTable\Field\Parameter\Position\tt_content_one:<props,0>
	 * @AirTable\Field\Parameter\Label:<Элемент содержимого>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\TtContent>
	 * @AirTable\Field\Parameter\ForeignKey:<marker_one>
	 */
	protected $tt_content_one;
	
	/**
	 * @AirTable\Field:<Rel_Poly_1toM>
	 * @AirTable\Field\Parameter\Position\tt_content_many:<props,0>
	 * @AirTable\Field\Parameter\Label:<Содержимое из элементов контента>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\TtContent>
	 * @AirTable\Field\Parameter\ForeignKey:<marker_one>
	 */
	protected $tt_content_many;
	
	/**
	 * @AirTable\Field:<FalImage>
	 * @AirTable\Field\Parameter\Position\image1:<props,0>
	 * @AirTable\Field\Parameter\Label:<Изображение>
	 */
	protected $image1;
	
	/**
	 * @AirTable\Field:<FalImages>
	 * @AirTable\Field\Parameter\Position\images:<props,0>
	 * @AirTable\Field\Parameter\Label:<Изображения>
	 */
	protected $images;
	
	/**
	 * @AirTable\Field:<FalFile>
	 * @AirTable\Field\Parameter\Position\file1:<props,0>
	 * @AirTable\Field\Parameter\Label:<Документ>
	 */
	protected $file1;
	
	/**
	 * @AirTable\Field:<FalFiles>
	 * @AirTable\Field\Parameter\Position\files:<props,0>
	 * @AirTable\Field\Parameter\Label:<Документы>
	 */
	protected $files;
	
	/**
	 * @AirTable\Field:<TextCode>
	 * @AirTable\Field\Parameter\Position\code_ts:<props,0>
	 * @AirTable\Field\Parameter\Label:<Typoscript-код>
	 * @AirTable\Field\Parameter\Format:<typoscript>
	 */
	protected $code_ts;
	
	/**
	 * @AirTable\Field:<TextCode>
	 * @AirTable\Field\Parameter\Position\code_html:<props,0>
	 * @AirTable\Field\Parameter\Label:<Html-код>
	 * @AirTable\Field\Parameter\Format:<html>
	 */
	protected $code_html;
	
	/**
	* Переопределение массива настроек таблицы
	* @configuration (TCA array)
	* @return array
	*/
    public static function postBuildConfiguration(&$configuration = [])
    {
		//$configuration['ctrl']['...'] = 1;
	}
}
?>