<?php
namespace Litovchenko\AirTable\Model;

/**
 * @AirTable:<Table>
 * @AirTable\Parameter\Label:<Таблица с примерами>
 * @AirTable\Parameter\Description:<Примеры доступных полей для редактирования>
 */
 
class ExampleTable extends \Litovchenko\AirTable\Model\BaseCrud
{
	use \Litovchenko\AirTable\Field\Traits\Title;
	use \Litovchenko\AirTable\Field\Traits\Disabled;
	use \Litovchenko\AirTable\Field\Traits\Deleted;
	use \Litovchenko\AirTable\Field\Traits\Sorting;
	use \Litovchenko\AirTable\Field\Traits\ParentId;
	use \Litovchenko\AirTable\Field\Traits\CategoryId;
	#use \Litovchenko\AirTable\Field\Traits\CategoryMany;
	
	/**
	* Табы по умолчанию
	* @return array
	*/
    public static function baseTabs()
    {
		$tabs = parent::baseTabs();
		$tabs['rel_1to1'] = 'Вариант связей 1:1 (###COUNT###)';
		$tabs['rel_1toM'] = 'Вариант связей 1:M (###COUNT###)';
		$tabs['rel_Mto1'] = 'Вариант связей M:1 (###COUNT###)';
		$tabs['rel_MtoM'] = 'Вариант связей M:M (###COUNT###)';
		$tabs['rel_poly_1to1'] = 'Вариант связей Poly 1:1 (###COUNT###)';
		$tabs['rel_poly_1toM'] = 'Вариант связей Poly 1:M (###COUNT###)';
		$tabs['rel_poly_MtoM'] = 'Вариант связей Poly M:M (###COUNT###)';
		$tabs['rel_error'] = 'Тест ошибок в связях (###COUNT###)';
		return $tabs;
	}
	
	/**
	 * @AirTable\Field:<Rel_1to1>
	 * @AirTable\Field\Parameter\Position\*:<rel_1to1,0>
	 * @AirTable\Field\Parameter\Label:<Тест связи №1>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable1>
	 * @AirTable\Field\Parameter\ForeignKey:<exampletable_id>
	 */
	protected $exampletable1_one;
	
	/**
	 * @AirTable\Field:<Rel_1to1>
	 * @AirTable\Field\Parameter\Position\*:<rel_1to1,0>
	 * @AirTable\Field\Parameter\Label:<Тест аналогичной связи №2>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable1>
	 * @AirTable\Field\Parameter\ForeignKey:<duplicate_exampletable_id>
	 */
	protected $duplicate_exampletable1_one;
	
	/**
	 * @AirTable\Field:<Rel_1to1>
	 * @AirTable\Field\Parameter\Position\*:<rel_1to1,0>
	 * @AirTable\Field\Parameter\Label:<Связь на себя>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable>
	 * @AirTable\Field\Parameter\ForeignKey:<current1_exampletable_id>
	 */
	protected $current1_exampletable_one;
	
	/**
	 * @AirTable\Field:<Rel_1to1>
	 * @AirTable\Field\Parameter\Position\*:<rel_1to1,0>
	 * @AirTable\Field\Parameter\Label:<Внешняя>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\FeUsers>
	 * @AirTable\Field\Parameter\ForeignKey:<external1_tx_air_table_examples1_exampletable_id>
	 */
	protected $external1_fe_users_one;




	
	/**
	 * @AirTable\Field:<Rel_1toM>
	 * @AirTable\Field\Parameter\Position\*:<rel_1toM,0>
	 * @AirTable\Field\Parameter\Label:<Тест связи №1>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable2>
	 * @AirTable\Field\Parameter\ForeignKey:<exampletable_id>
	 */
	protected $exampletable2_many;
	
	/**
	 * @AirTable\Field:<Rel_1toM>
	 * @AirTable\Field\Parameter\Position\*:<rel_1toM,0>
	 * @AirTable\Field\Parameter\Label:<Тест аналогичной связи №2>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable2>
	 * @AirTable\Field\Parameter\ForeignKey:<duplicate_exampletable_id>
	 */
	protected $duplicate_exampletable2_many;
	
	/**
	 * @AirTable\Field:<Rel_1toM>
	 * @AirTable\Field\Parameter\Position\*:<rel_1toM,0>
	 * @AirTable\Field\Parameter\Label:<Связь на себя>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable>
	 * @AirTable\Field\Parameter\ForeignKey:<current2_exampletable_id>
	 */
	protected $current2_exampletable_many;
	
	/**
	 * @AirTable\Field:<Rel_1toM>
	 * @AirTable\Field\Parameter\Position\*:<rel_1toM,0>
	 * @AirTable\Field\Parameter\Label:<Внешняя>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\FeUsers>
	 * @AirTable\Field\Parameter\ForeignKey:<external2_tx_air_table_examples1_exampletable_id>
	 */
	protected $external2_fe_users_many;




	
	/**
	 * @AirTable\Field:<Rel_Mto1>
	 * @AirTable\Field\Parameter\Position\*:<rel_Mto1,0>
	 * @AirTable\Field\Parameter\Label:<Тест связи №1>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable3>
	 * @AirTable\Field\Parameter\ForeignKey:<exampletable_many>
	 */
	protected $exampletable3_id;
	
	/**
	 * @AirTable\Field:<Rel_Mto1>
	 * @AirTable\Field\Parameter\Position\*:<rel_Mto1,0>
	 * @AirTable\Field\Parameter\Label:<Тест аналогичной связи №2>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable3>
	 * @AirTable\Field\Parameter\ForeignKey:<duplicate_exampletable_many>
	 */
	protected $duplicate_exampletable3_id;
	
	/**
	 * @AirTable\Field:<Rel_Mto1>
	 * @AirTable\Field\Parameter\Position\*:<rel_Mto1,0>
	 * @AirTable\Field\Parameter\Label:<Связь на себя>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable>
	 * @AirTable\Field\Parameter\ForeignKey:<current3_exampletable_many>
	 */
	 protected $current3_exampletable_id;
	
	/**
	 * @AirTable\Field:<Rel_Mto1>
	 * @AirTable\Field\Parameter\Position\*:<rel_Mto1,0>
	 * @AirTable\Field\Parameter\Label:<Rel_Mto1 (внешняя)>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\FeUsers>
	 * @AirTable\Field\Parameter\ForeignKey:<external3_tx_air_table_examples1_exampletable_many>
	 */
	protected $external3_fe_users_id;
	
	/**
	 * @AirTable\Field:<Rel_Mto1>
	 * @AirTable\Field\Parameter\Position\*:<rel_Mto1,0>
	 * @AirTable\Field\Parameter\Label:<RenderType:db>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable3>
	 * @AirTable\Field\Parameter\ForeignKey:<db_exampletable_many>
	 * @AirTable\Field\Parameter\RenderType:<db>
	 */
	protected $db_exampletable3_id;
	
	/**
	 * @AirTable\Field:<Rel_Mto1>
	 * @AirTable\Field\Parameter\Position\*:<rel_Mto1,0>
	 * @AirTable\Field\Parameter\Label:<RenderType:tree>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\Pages>
	 * @AirTable\Field\Parameter\ForeignKey:<treem1_tx_air_table_examples1_exampletable_many>
	 * @AirTable\Field\Parameter\RenderType:<tree>
	 * @AirTable\Field\Parameter\ParentKey:<pid>
	 */
	protected $treem1_pages_id;





	/**
	 * @AirTable\Field:<Rel_MtoM>
	 * @AirTable\Field\Parameter\Position\*:<rel_MtoM,0>
	 * @AirTable\Field\Parameter\Label:<Тест связи №1>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable4>
	 * @AirTable\Field\Parameter\ForeignKey:<exampletable_many>
	 */
	protected $exampletable4_many;
	
	/**
	 * @AirTable\Field:<Rel_MtoM>
	 * @AirTable\Field\Parameter\Position\*:<rel_MtoM,0>
	 * @AirTable\Field\Parameter\Label:<Тест аналогичной связи №2>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable4>
	 * @AirTable\Field\Parameter\ForeignKey:<duplicate_exampletable_many>
	 */
	protected $duplicate_exampletable4_many;
	
	/**
	 * @AirTable\Field:<Rel_MtoM>
	 * @AirTable\Field\Parameter\Position\*:<rel_MtoM,0>
	 * @AirTable\Field\Parameter\Label:<Связь на себя>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable>
	 * @AirTable\Field\Parameter\ForeignKey:<current4_exampletable_many>
	 */
	protected $current4_exampletable_many;
	
	/**
	 * @AirTable\Field:<Rel_MtoM>
	 * @AirTable\Field\Parameter\Position\*:<rel_MtoM,0>
	 * @AirTable\Field\Parameter\Label:<Внешняя>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\FeUsers>
	 * @AirTable\Field\Parameter\ForeignKey:<external4_tx_air_table_examples1_exampletable_many>
	 */
	protected $external4_fe_users_many;
	
	/**
	 * @AirTable\Field:<Rel_MtoM>
	 * @AirTable\Field\Parameter\Position\*:<rel_MtoM,0>
	 * @AirTable\Field\Parameter\Label:<RenderType:db>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable4>
	 * @AirTable\Field\Parameter\ForeignKey:<db_exampletable_many>
	 * @AirTable\Field\Parameter\RenderType:<db>
	 */
	protected $db_exampletable4_many;
	
	/**
	 * @AirTable\Field:<Rel_MtoM>
	 * @AirTable\Field\Parameter\Position\*:<rel_MtoM,0>
	 * @AirTable\Field\Parameter\Label:<RenderType:tree>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\Pages>
	 * @AirTable\Field\Parameter\ForeignKey:<treemm_tx_air_table_examples1_exampletable_many>
	 * @AirTable\Field\Parameter\RenderType:<tree>
	 * @AirTable\Field\Parameter\ParentKey:<pid>
	 */
	protected $treemm_pages_many;




	/**
	 * @AirTable\Field:<Rel_Poly_1to1>
	 * @AirTable\Field\Parameter\Position\*:<rel_poly_1to1,0>
	 * @AirTable\Field\Parameter\Label:<Тест связи №1>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable5>
	 * @AirTable\Field\Parameter\ForeignKey:<exampletable_one>
	 */
	protected $exampletable5_one;
	
	/**
	 * @AirTable\Field:<Rel_Poly_1to1>
	 * @AirTable\Field\Parameter\Position\*:<rel_poly_1to1,0>
	 * @AirTable\Field\Parameter\Label:<Тест аналогичной связи №2>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable5>
	 * @AirTable\Field\Parameter\ForeignKey:<duplicate_exampletable_one>
	 */
	protected $duplicate_exampletable5_one;
	
	/**
	 * @AirTable\Field:<Rel_Poly_1to1>
	 * @AirTable\Field\Parameter\Position\*:<rel_poly_1to1,0>
	 * @AirTable\Field\Parameter\Label:<Связь на себя>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable>
	 * @AirTable\Field\Parameter\ForeignKey:<current5_exampletable_one>
	 */
	protected $current5_exampletable_one;
	
	/**
	 * @AirTable\Field:<Rel_Poly_1to1>
	 * @AirTable\Field\Parameter\Position\*:<rel_poly_1to1,0>
	 * @AirTable\Field\Parameter\Label:<Внешняя>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\FeUsers>
	 * @AirTable\Field\Parameter\ForeignKey:<five_tx_air_table_examples1_exampletable_one>
	 */
	protected $five_fe_users_one;





	/**
	 * @AirTable\Field:<Rel_Poly_1toM>
	 * @AirTable\Field\Parameter\Position\*:<rel_poly_1toM,0>
	 * @AirTable\Field\Parameter\Label:<Тест связи №1>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable6>
	 * @AirTable\Field\Parameter\ForeignKey:<exampletable_one>
	 */
	protected $exampletable6_many;
	
	/**
	 * @AirTable\Field:<Rel_Poly_1toM>
	 * @AirTable\Field\Parameter\Position\*:<rel_poly_1toM,0>
	 * @AirTable\Field\Parameter\Label:<Тест аналогичной связи №2>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable6>
	 * @AirTable\Field\Parameter\ForeignKey:<duplicate_exampletable_one>
	 */
	protected $duplicate_exampletable6_many;
	
	/**
	 * @AirTable\Field:<Rel_Poly_1toM>
	 * @AirTable\Field\Parameter\Position\*:<rel_poly_1toM,0>
	 * @AirTable\Field\Parameter\Label:<Связь на себя>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable>
	 * @AirTable\Field\Parameter\ForeignKey:<current6_exampletable_one>
	 */
	protected $current6_exampletable_many;
	
	/**
	 * @AirTable\Field:<Rel_Poly_1toM>
	 * @AirTable\Field\Parameter\Position\*:<rel_poly_1toM,0>
	 * @AirTable\Field\Parameter\Label:<Внешняя>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\FeUsers>
	 * @AirTable\Field\Parameter\ForeignKey:<six_tx_air_table_examples1_exampletable_one>
	 */
	protected $six_fe_users_many;





	/**
	 * @AirTable\Field:<Rel_Poly_MtoM>
	 * @AirTable\Field\Parameter\Position\*:<rel_poly_MtoM,0>
	 * @AirTable\Field\Parameter\Label:<Тест связи №1>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable7>
	 * @AirTable\Field\Parameter\ForeignKey:<exampletable_many>
	 */
	#protected $exampletable7_many;
	
	/**
	 * @AirTable\Field:<Rel_Poly_MtoM>
	 * @AirTable\Field\Parameter\Position\*:<rel_poly_MtoM,0>
	 * @AirTable\Field\Parameter\Label:<Тест аналогичной связи №2>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable7>
	 * @AirTable\Field\Parameter\ForeignKey:<duplicate_exampletable_many>
	 */
	#protected $duplicate_exampletable7_many;
	
	/**
	 * @AirTable\Field:<Rel_Poly_MtoM>
	 * @AirTable\Field\Parameter\Position\*:<rel_poly_MtoM,0>
	 * @AirTable\Field\Parameter\Label:<Связь на себя>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\ExampleTable>
	 * @AirTable\Field\Parameter\ForeignKey:<current7_exampletable_many>
	 */
	#protected $current7_exampletable_many;
	
	/**
	 * @AirTable\Field:<Rel_Poly_MtoM>
	 * @AirTable\Field\Parameter\Position\*:<rel_poly_MtoM,0>
	 * @AirTable\Field\Parameter\Label:<Внешняя>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\FeUsers>
	 * @AirTable\Field\Parameter\ForeignKey:<seven_tx_air_table_examples1_exampletable_many>
	 */
	#protected $seven_fe_users_many;
	




	/**
	 * @AirTable\Field:<Rel_MtoM>
	 * @AirTable\Field\Parameter\Position\*:<rel_error,0>
	 * @AirTable\Field\Parameter\Label:<№1>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\Blabla>
	 * @AirTable\Field\Parameter\ForeignKey:<treemm_tx_airtable_model_exampletable_list>
	 */
	protected $blabla_pages_many;
	
	/**
	 * @AirTable\Field:<Rel_MtoM>
	 * @AirTable\Field\Parameter\Position\*:<rel_error,0>
	 * @AirTable\Field\Parameter\Label:<№2>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\Pages>
	 * @AirTable\Field\Parameter\ForeignKey:<test_tx_airtable_model_exampletable_list>
	 */
	protected $test_pa4ges_manyefwfew;

	/**
	* Переопределение массива настроек таблицы
	* @configuration (TCA array)
	* @return array
	*/
    public static function postBuildConfiguration(&$configuration = [])
    {
		//$configuration['ctrl']['...'] = 1;
	}
}
?>