<?php
namespace Litovchenko\AirTable\DefaultProperty\Model;

/**
 * @AirTable:<Table>
 * @AirTable\Parameter\Label:<Тест полей: дефолтовые поля>
 * @AirTable\Parameter\Description:<Примеры доступных полей для редактирования>
 * @AirTable\Parameter\PidAny:<1>
 */
 
class TestDefaultFields extends \Litovchenko\AirTable\Model\BaseCrud
{
	use \Litovchenko\AirTable\Field\Traits\RType;
	use \Litovchenko\AirTable\Field\Traits\Slug;
	use \Litovchenko\AirTable\Field\Traits\Title;
	use \Litovchenko\AirTable\Field\Traits\AltTitle;
	use \Litovchenko\AirTable\Field\Traits\Disabled;
	use \Litovchenko\AirTable\Field\Traits\Deleted;
	use \Litovchenko\AirTable\Field\Traits\Sorting;
	use \Litovchenko\AirTable\Field\Traits\DateCreate;
	use \Litovchenko\AirTable\Field\Traits\DateUpdate;
	use \Litovchenko\AirTable\Field\Traits\DateStart;
	use \Litovchenko\AirTable\Field\Traits\DateEnd;
	use \Litovchenko\AirTable\Field\Traits\ServiceNote;
	use \Litovchenko\AirTable\Field\Traits\BeUserId;
	use \Litovchenko\AirTable\Field\Traits\TextAndPicPreview;
	use \Litovchenko\AirTable\Field\Traits\TextAndPicDetail;
	use \Litovchenko\AirTable\Field\Traits\TtContentMany;
	use \Litovchenko\AirTable\Field\Traits\Files;
	use \Litovchenko\AirTable\Field\Traits\ParentId;
	#use \Litovchenko\AirTable\Field\Traits\CategoryId;
	use \Litovchenko\AirTable\Field\Traits\CategoryMany;
	
	/**
	* Типы записей по умолчанию
	* @return array
	*/
    public static function baseRTypes()
    {
		return [
			1 => 'Тип 1',
			2 => 'Тип 2',
			3 => 'Тип 3'
		];
	}
	
	/**
	 * @AirTable\Field:<Input>
	 * @AirTable\Field\Parameter\Position\1:<props,10>
	 * @AirTable\Field\Parameter\Label:<Тестовое поле №1 (только для типа 1)>
	 */
	protected $test_field;
	
	/**
	 * @AirTable\Field:<Input>
	 * @AirTable\Field\Parameter\Position\2:<props,10>
	 * @AirTable\Field\Parameter\Label:<Тестовое поле №21 (только для типа 2)>
	 */
	protected $test_field2;
	
	/**
	 * @AirTable\Field:<Input>
	 * @AirTable\Field\Parameter\Position\*:<props,10>
	 * @AirTable\Field\Parameter\Label:<Тестовое поле №3 (для всех типов)>
	 */
	protected $test_field3;
	
	/**
	 * @AirTable\Field:<Input>
	 * @AirTable\Field\Parameter\Position\*:<main,10>
	 * @AirTable\Field\Parameter\Label:<Тестовое поле №4 (для всех типов, на вкладке "main")>
	 */
	protected $test_field4;
	
	/**
	 * @AirTable\Field:<TextCode>
	 * @AirTable\Field\Parameter\Label:<Включиться с ошибкой №А>
	 * @AirTable\Field\Parameter\Format:<html>
	 */
	protected $test;
	
	/**
	 * @AirTable\Field:<TextCode>
	 * @AirTable\Field\Parameter\Position\1:<props2,0>
	 * @AirTable\Field\Parameter\Label:<Включиться с ошибкой №Б>
	 * @AirTable\Field\Parameter\Format:<html>
	 */
	protected $test2;
	
	/**
	 * @AirTable\Field:<TextCode>
	 * @AirTable\Field\Parameter\Position\57:<nubkj,0>
	 * @AirTable\Field\Parameter\Label:<Включиться с ошибкой №В>
	 * @AirTable\Field\Parameter\Format:<html>
	 */
	protected $test3;
	
	/**
	 * @AirTable\Field:<TextCode>
	 * @AirTable\Field\Parameter\Position\57:<props,0>
	 * @AirTable\Field\Parameter\Label:<Включиться с ошибкой №Г>
	 * @AirTable\Field\Parameter\Format:<html>
	 */
	protected $test4;
	
	/**
	 * @AirTable\Field:<TextCode>
	 * @AirTable\Field\Parameter\Position\*:<props2,0>
	 * @AirTable\Field\Parameter\Label:<Включиться с ошибкой №Д>
	 * @AirTable\Field\Parameter\Format:<html>
	 */
	protected $test5;
	
	/**
	* Переопределение массива настроек таблицы
	* @configuration (TCA array)
	* @return array
	*/
    public static function postBuildConfiguration(&$configuration = [])
    {
		//$configuration['ctrl']['...'] = 1;
	}
}