<?php
namespace Litovchenko\AirTable\Blog\Model;

/**
 * @AirTable:<Table>
 * @AirTable\Parameter\Label:<Пост>
 * @AirTable\Parameter\TextAndPicDetail:<1>
 */

class Post extends \Litovchenko\AirTable\Model\BaseCrud
{
	use \Litovchenko\AirTable\Field\Traits\Title;
	use \Litovchenko\AirTable\Field\Traits\Disabled;
	use \Litovchenko\AirTable\Field\Traits\Deleted;
	use \Litovchenko\AirTable\Field\Traits\Sorting;
	
	/**
	 * @AirTable\Field:<Rel_Mto1>
	 * @AirTable\Field\Parameter\Label:<Блог>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Blog\Model\Blog>
	 * @AirTable\Field\Parameter\ForeignKey:<post_many>
	 */
	protected $blog_id;

	/**
	 * @AirTable\Field:<Rel_MtoM>
	 * @AirTable\Field\Parameter\Label:<Теги>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Blog\Model\Tag>
	 * @AirTable\Field\Parameter\ForeignKey:<post_many>
	 */
	protected $tag_many;
	
	/**
	 * @AirTable\Field:<Rel_Mto1>
	 * @AirTable\Field\Parameter\Label:<Автор>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Blog\Model\Author>
	 * @AirTable\Field\Parameter\ForeignKey:<post_many>
	 */
	protected $author_id;
	
	/**
	 * @AirTable\Field:<Rel_Poly_1toM>
	 * @AirTable\Field\Parameter\Label:<Комментарии>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Blog\Model\Comment>
	 * @AirTable\Field\Parameter\ForeignKey:<post_many>
	 */
	protected $comment_many;
}
?>