<?php
namespace Litovchenko\AirTable\Model;

/**
 * @AirTable:<Table>
 * @AirTable\Parameter\Label:<Файловая система: файл>
 * @AirTable\Parameter\Description:<Регистрация модели в системе>
 * @AirTable\Parameter\TableKey:<sys_file>
 */

class SysFile extends \Litovchenko\AirTable\Model\BaseCrud2
{
	/**
	 * @AirTable\Field:<SpecialFalFileInfo>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\Label:<Префью>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $fileinfo;
	
	/**
	 * @AirTable\Field:<Input>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $name;
	
	/**
	 * @AirTable\Field:<Input>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $sha1;
	
	/**
	 * @AirTable\Field:<InputNumber>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $size;
	
	/**
	 * @AirTable\Field:<Input>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $mime_type;
	
	/**
	 * @AirTable\Field:<SwitchInt>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $type;
	
	/**
	 * @AirTable\Field:<Flag>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $missing;
	
	/**
	 * @AirTable\Field:<Rel_Mto1>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\SysFileStorage>
	 * @AirTable\Field\Parameter\ForeignKey:<file>
	 * @AirTable\Field\Parameter\DoNotCheck:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 * @AirTable\Field\Parameter\ReadOnly:<0>
	 */
	protected $storage;
	
	/**
	 * @AirTable\Field:<Rel_1to1>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\SysFileMetadata>
	 * @AirTable\Field\Parameter\ForeignKey:<file>
	 * @AirTable\Field\Parameter\DoNotCheck:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 * @AirTable\Field\Parameter\ReadOnly:<0>
	 */
	protected $metadata;
	
	/**
	* Переопределение массива настроек таблицы
	* @configuration (TCA array)
	* @return array
	*/
    public static function postBuildConfiguration(&$configuration = [])
    {
		// Общие настройки
		$configuration['ctrl']['hideTable'] = 0;
		#\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes('sys_file', 'metadata', '', 'after:storage');
	}
}
?>