<?php
namespace Litovchenko\AirTable\Model;

/**
 * @AirTable:<Table>
 * @AirTable\Parameter\Label:<Файловая система: файл (описание)>
 * @AirTable\Parameter\Description:<Регистрация модели в системе>
 * @AirTable\Parameter\TableKey:<sys_file_metadata>
 */

class SysFileMetadata extends \Litovchenko\AirTable\Model\BaseCrud2
{
	/**
	 * @AirTable\Field:<SpecialFalFileInfo>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\Label:<Префью>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $fileinfo;
	
	/**
	 * @AirTable\Field:<Input>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $title;
	
	/**
	 * @AirTable\Field:<Text>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $description;
	
	/**
	 * @AirTable\Field:<Rel_1to1_Revers>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\SysFile>
	 * @AirTable\Field\Parameter\ForeignKey:<metadata>
	 * @AirTable\Field\Parameter\DoNotCheck:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 * @AirTable\Field\Parameter\ReadOnly:<0>
	 */
	protected $file;
	
	/**
	* Переопределение массива настроек таблицы
	* @configuration (TCA array)
	* @return array
	*/
    public static function postBuildConfiguration(&$configuration = [])
    {
		// Общие настройки
		$configuration['ctrl']['hideTable'] = 0;
		$configuration['columns']['file']['config']['foreign_table_where'] = ' AND sys_file.uid = ###REC_FIELD_file###' ;
		#\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes('sys_file_metadata', 'file', '', '');
	}
	
}
?>