<?php
namespace Litovchenko\AirTable\Model;

/**
 * @AirTable:<Table>
 * @AirTable\Parameter\Label:<Файловая система: ссылка на файл>
 * @AirTable\Parameter\Description:<Регистрация модели в системе>
 * @AirTable\Parameter\TableKey:<sys_file_reference>
 */

class SysFileReference extends \Litovchenko\AirTable\Model\BaseCrud2
{
	/**
	 * @AirTable\Field:<Input>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $title;
	
	/**
	 * @AirTable\Field:<Text>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $description;
	
	/**
	 * @AirTable\Field:<FlagDisabled>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $hidden;
	
	/**
	 * @AirTable\Field:<Rel_Mto1>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\SysFile>
	 * @AirTable\Field\Parameter\ForeignKey:<reference>
	 * @AirTable\Field\Parameter\RenderType:<db>
	 */
	protected $uid_local;
	
	/**
	* Переопределение массива настроек таблицы
	* @configuration (TCA array)
	* @return array
	*/
    public static function postBuildConfiguration(&$configuration = [])
    {
		// Общие настройки
		$configuration['ctrl']['hideTable'] = 0;
		// $configuration['columns']['uid_local']['config']['hideSuggest'] = false;
		// $configuration['palettes']['filePalette']['isHiddenPalette'] = 0;
		
		// Todo - решить что делать с этими колонками,
		// Зависит от того как оформим полиморфизм
		// Запись, к которой привязана ссылка на файл
		// \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes('sys_file_reference', 'tablenames', '', '');
		// \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes('sys_file_reference', 'fieldname', '', '');
		// \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes('sys_file_reference', 'uid_foreign', '', '');
		// \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes('sys_file_reference', 'sorting_foreign', '', '');
	}

}
?>