<?php
namespace Litovchenko\AirTable\Model;

/**
 * @AirTable:<Table>
 * @AirTable\Parameter\Label:<Связь M:M>
 * @AirTable\Parameter\TableKey:<sys_mm>
 */
class SysMm extends \Litovchenko\AirTable\Model\BaseCrud
{
	/**
	* Табы по умолчанию
	* @return array
	*/
    public static function baseTabs()
    {
		$tabs = parent::baseTabs();
		$tabs['local'] = 'Локальные данные (где выбрано?)';
		$tabs['foreign'] = 'Внешние данные (что выбрано?)';
		$tabs['indent'] = 'Дополнительные данные';
		return $tabs;
	}
	
	/**
	 * @AirTable\Field:<Input>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\Position\*:<local,0>
	 * @AirTable\Field\Parameter\Label:<Таблица локальная>
	 * @AirTable\Field\Parameter\Items\0:<Значение не выбрано>
	 * @AirTable\Field\Parameter\ReadOnly:<0>
	 */
	protected $tablename; // SwitchVarchar -> Решил оставить SysMm
	
	/**
	 * @AirTable\Field:<Input>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\Position\*:<local,1>
	 * @AirTable\Field\Parameter\Label:<Колонка локальная>
	 */
	protected $fieldname;
	
	/**
	 * @AirTable\Field:<InputNumber>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\Position\*:<local,2>
	 * @AirTable\Field\Parameter\Label:<Ключ (ID) локальный>
	 */
	protected $uid_local;
	
	/**
	 * @AirTable\Field:<InputNumber>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\Position\*:<local,3>
	 * @AirTable\Field\Parameter\Label:<Сортировка локальная>
	 */
	protected $sorting;
	
	/**
	 * @AirTable\Field:<InputNumber>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\Position\*:<foreign,1>
	 * @AirTable\Field\Parameter\Label:<Ключ (ID) внешний>
	 */
	protected $uid_foreign;
	
	/**
	 * @AirTable\Field:<InputNumber>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\Position\*:<foreign,2>
	 * @AirTable\Field\Parameter\Label:<Сортировка внешняя>
	 */
	protected $sorting_foreign;
	
	/**
	 * @AirTable\Field:<Text>
	 * @AirTable\Field\Parameter\Position\*:<indent,0>
	 * @AirTable\Field\Parameter\Label:<Дополнительные данные>
	 */
	protected $ident;
	
	/**
	* Переопределение массива настроек таблицы
	* @configuration (TCA array)
	* @return array
	*/
    public static function postBuildConfiguration(&$configuration = [])
    {
		$configuration['ctrl']['label'] = 'tablename';
		
		// Для полиморфизма Poly-M:M - Todo
		// Если не идет процесс редактирования записи в таблице "sys_mm" устанавливаем Select-конфиги
		#if(!isset($GLOBALS['_GET']['edit']['sys_mm'])){
			#$configuration['columns']['uid_local']['config']['type'] = 'select';
			#$configuration['columns']['uid_local']['config']['renderType'] = 'selectSingle';
			#$configuration['columns']['uid_local']['config']['foreign_table'] = 'tx_air_table_examples1_exampletable';
			#$configuration['columns']['uid_local']['config']['items'][] = [0=>'-- Выберите значение --',1=>''];
			#$configuration['columns']['uid_foreign']['config']['type'] = 'select';
			#$configuration['columns']['uid_foreign']['config']['renderType'] = 'selectSingle';
			#$configuration['columns']['uid_foreign']['config']['foreign_table'] = 'tx_air_table_examples1_exampletable7';
			#$configuration['columns']['uid_foreign']['config']['items'][] = [0=>'-- Выберите значение --',1=>''];
		#}
	}
	
}
?>