<?php
namespace Litovchenko\AirTable\Model;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Table>
 * @AirTable\Parameter\Label:<Заметка>
 * @AirTable\Parameter\Description:<Регистрация модели в системе>
 * @AirTable\Parameter\TableKey:<sys_note>
 */
class SysNote extends \Litovchenko\AirTable\Model\BaseCrud2
{
	/**
	 * @AirTable\Field:<DateTime>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\Label:<Дата создания>
	 * @AirTable\Field\Parameter\DoNotCheck:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $crdate;
	
	/**
	 * @AirTable\Field:<Input>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $subject;
	
	/**
	 * @AirTable\Field:<Text>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 */
	protected $message;
	
	/**
	 * -- NEW FIELD --
	 * @AirTable\Field:<SwitchVarchar>
	 * @AirTable\Field\Parameter\Label:<Модель>
	 * @AirTable\Field\Parameter\Show:<1>
	 */
	protected $ex_air_table_modelname;
	
	/**
	 * @AirTable\Field:<Rel_Mto1>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\Label:<Автор записи>
	 * @AirTable\Field\Parameter\ForeignModel:<Litovchenko\AirTable\Model\BeUsers>
	 * @AirTable\Field\Parameter\ForeignKey:<sys_note_many>
	 * @AirTable\Field\Parameter\DoNotCheck:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 * @AirTable\Field\Parameter\ReadOnly:<1>
	 */
	protected $cruser;
	
	/**
	* Переопределение массива настроек таблицы
	* @configuration (TCA array)
	* @return array
	*/
    public static function postBuildConfiguration(&$configuration = [])
    {
		// Разрешаем создание записей в корне дерева страниц сайта
		$configuration['ctrl']['rootLevel'] = -1;
		
		// Устанавливаем время по умолчанию
		$configuration['columns']['crdate']['config']['default'] = time();
		
		// Заполняем списком моделей
		$configuration['columns']['ex_air_table_modelname']['config']['items'] = [];
		foreach($GLOBALS['TCA'] as $k => $v){
			if(isset($v['ctrl']['AirTable.Class']) && class_exists($v['ctrl']['AirTable.Class'])){
				$tableLabel = BaseUtility::getClassAnnotationValueNew($v['ctrl']['AirTable.Class'],'AirTable\Parameter\Label');
				$configuration['columns']['ex_air_table_modelname']['config']['items'][] = [
					0=>$tableLabel,
					1=>$v['ctrl']['AirTable.Class']
				];
			}
		}
	}
	
}
?>