<?php
namespace Litovchenko\AirTable\Model\Traits;

trait TraitUidPid
{
	/**
	 * @AirTable\Field:<SpecialUid>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\Position\*:<main,0>
	 * @AirTable\Field\Parameter\Label:<ID>
	 * @AirTable\Field\Parameter\LiveSearch:<1>
	 * @AirTable\Field\Parameter\DoNotCheck:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 * @AirTable\Field\Parameter\ReadOnly:<1>
	 */
	protected $uid;
	
	/**
	 * @AirTable\Field:<PassthroughInt>
	 * @AirTable\Field\Parameter\Show:<1>
	 * @AirTable\Field\Parameter\Position\*:<main,0>
	 * @AirTable\Field\Parameter\Label:<PID>
	 * @AirTable\Field\Parameter\DoNotCheck:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 * @AirTable\Field\Parameter\ReadOnly:<1>
	 */
	protected $pid;
	
	/**
	 * @AirTable\Field:<InputNumber>
	 * @AirTable\Field\Parameter\Show:<0>
	 * @AirTable\Field\Parameter\Position\*:<extended,1000>
	 * @AirTable\Field\Parameter\Label:<[IMPORT] PROCESS>
	 * @AirTable\Field\Parameter\DoNotCheck:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 * @AirTable\Field\Parameter\ReadOnly:<1>
	 */
	protected $importprocess;

	/**
	 * @AirTable\Field:<InputNumber>
	 * @AirTable\Field\Parameter\Show:<0>
	 * @AirTable\Field\Parameter\Position\*:<extended,1000>
	 * @AirTable\Field\Parameter\Label:<[IMPORT] OLD ID>
	 * @AirTable\Field\Parameter\DoNotCheck:<1>
	 * @AirTable\Field\Parameter\DoNotSqlAnalyze:<1>
	 * @AirTable\Field\Parameter\ReadOnly:<1>
	 */	
	protected $importolduid;
	
    /**
     * @return int
     */
    public function getUid()
    {
        return $this->getAttribute('uid');
    }

    /**
     * @param int $val
     */
    public function setUid($val)
    {
		return $this->setAttribute('uid',$val);
    }
	
    /**
     * @return int
     */
    public function getPid()
    {
        return $this->getAttribute('pid');
    }

    /**
     * @param int $val
     */
    public function setPid($val = 0)
    {
		return $this->setAttribute('pid',$val);
    }
}