<?php
namespace Litovchenko\AirTable\Field;
use Litovchenko\AirTable\Field\BaseField;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Field>
 * @AirTable\Parameter\Label:<Файл>
 */
class FalFile extends BaseField
{
	const EXPORT = false;
	
	const IMPORT = false;
	
    /**
     * @return string
     */
    public static function databaseDefinitions($model, $table, $field)
    {
        return [$table=>[
			$field => 'int(11) DEFAULT \'0\' NOT NULL'
		]];
    }
	
    /**
     * @return string
     */
    public static function parameterMinitems($class, $property, $keyAnnotation, $value)
    {
        return $value;
    }

    /**
     * @modify array
     */
    public static function buildConfiguration($model, $table, $field)
    {
		$GLOBALS['TCA'][$table]['columns'][$field]['config'] = \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::getFileFieldTCAConfig('',[],'','php,php3');
		parent::buildConfiguration($model,$table,$field);
		
		$GLOBALS['TCA'][$table]['columns'][$field]['label'] = $GLOBALS['TCA'][$table]['columns'][$field]['label'].' FAL';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['appearance']['headerThumbnail']['width'] = 80;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['appearance']['headerThumbnail']['height'] = 100;
		
		// Минимальное кол-во
		$minitems = BaseUtility::getClassFieldAnnotationValueNew($model,$field,'AirTable\Field\Parameter\Minitems');
		if(!empty($minitems)){
			$GLOBALS['TCA'][$table]['columns'][$field]['config']['minitems'] = $minitems;
		}
		
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['maxitems'] = 1;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['foreign_match_fields'] = [
            // 'table_local' => 'sys_file',
            'tablenames' => $model,
			'fieldname' => $field,
		];
		
		// Лишнее поле - с ним не получилось записывать не таблицу, а модель
		unset($GLOBALS['TCA'][$table]['columns'][$field]['config']['foreign_table_field']);
		#print "<pre>";
		#print_r($GLOBALS['TCA'][$table]['columns'][$field]);
		#exit();
    }
	
	// listController func
	public static function listControllerSqlBuilder(&$obj, &$q, $table, $field, $config){
		// $q->addSelect($table.'.'.$field);
		$paramFilter_select = BaseUtility::_POSTuc('form1Apply','form1Field_'.$field,'');
		switch($paramFilter_select){
			case 'F0': $q = $q->has('getDefaultRelation_'.$field.'_Method', '=', 0); break;
			case 'F1': $q = $q->has('getDefaultRelation_'.$field.'_Method', '=', 1); break;
			case 'F2': $q = $q->has('getDefaultRelation_'.$field.'_Method', '=', 2); break;
			case 'F3': $q = $q->has('getDefaultRelation_'.$field.'_Method', '=', 3); break;
			case 'F4': $q = $q->has('getDefaultRelation_'.$field.'_Method', '=', 4); break;
			case 'F5': $q = $q->has('getDefaultRelation_'.$field.'_Method', '=', 5); break;
			case 'F6': $q = $q->has('getDefaultRelation_'.$field.'_Method', '=', 6); break;
			case 'F7': $q = $q->has('getDefaultRelation_'.$field.'_Method', '=', 7); break;
			case 'F8': $q = $q->has('getDefaultRelation_'.$field.'_Method', '=', 8); break;
			case 'F9': $q = $q->has('getDefaultRelation_'.$field.'_Method', '=', 9); break;
			case 'F10': $q = $q->has('getDefaultRelation_'.$field.'_Method', '=', 10); break;
			case 'F10+':
				$q = $q->has('getDefaultRelation_'.$field.'_Method', '>', 10);
			break;
		}
		return $q;
	}
	
	// listController func
	public static function listControllerSqlBuilderWith(&$obj, &$q, $table, $field, $config)
	{
		return $q->with(['getDefaultRelation_'.$field.'_Method'=>function($query){
			// $query->select('uid,pid,title,deleted,hidden,uid_local,tablenames,fieldname,uid_foreign,sorting_foreign');
			$query->with(['getDefaultRelation_uid_local_Method'=>function($query){
				// $query->select('uid,storage,metadata,name,sha1,identifier');
				$query->with(['getDefaultRelation_storage_Method'=>function($query){}]); // $query->select('uid,configuration');
				// $query->with(['getDefaultRelation_metadata_Method'=>function($query){}]); // $query->select('uid,title,file');
			}]);
		}]);
	}
	
	// listController func
	public static function listControllerSqlBuilderOrder(){
		return false;
	}
	
	// listController func
	public static function listControllerHtmlFilter(&$obj, $table, $field, $config){
		$paramFilter_select = BaseUtility::_POSTuc('form1Apply','form1Field_'.$field,'');
		return '
			<select name="form1Field_'.$field.'" class="form-control btn-sm">
				<option value="" '.($paramFilter_select == ''?'selected':'').'>Любое значение</option>
				<option value="F0" '.($paramFilter_select == 'F0'?'selected':'').'>0 файлов</option>
				<option value="F1" '.($paramFilter_select == 'F1'?'selected':'').'>1 файл</option>
				<option value="F2" '.($paramFilter_select == 'F2'?'selected':'').'>2 файла</option>
				<option value="F3" '.($paramFilter_select == 'F3'?'selected':'').'>3 файла</option>
				<option value="F4" '.($paramFilter_select == 'F4'?'selected':'').'>4 файла</option>
				<option value="F5" '.($paramFilter_select == 'F5'?'selected':'').'>5 файлов</option>
				<option value="F6" '.($paramFilter_select == 'F6'?'selected':'').'>6 файлов</option>
				<option value="F7" '.($paramFilter_select == 'F7'?'selected':'').'>7 файлов</option>
				<option value="F8" '.($paramFilter_select == 'F8'?'selected':'').'>8 файлов</option>
				<option value="F9" '.($paramFilter_select == 'F9'?'selected':'').'>9 файлов</option>
				<option value="F10" '.($paramFilter_select == 'F10'?'selected':'').'>10 файлов</option>
				<option value="F10+" '.($paramFilter_select == 'F10+'?'selected':'').'>Более 10 файлов</option>
			</select>
		';
	}
	
	// listController func
	public static function listControllerHtmlTh(&$obj, $table, $field, $config){
		return \Litovchenko\AirTable\Field\Input::listControllerHtmlTh($obj, $table, $field, $config);
	}
	
	// listController func
	public static function listControllerHtmlTd(&$obj, $table, $field, $config, $row, &$uriBuilder){
		$backendLink = \TYPO3\CMS\Backend\Utility\BackendUtility::getModuleUrl(
			'record_edit', [
				'columnsOnly' => $field,
				'edit['.$table.']['.$row['uid'].']' => 'edit',
				'returnUrl' => \TYPO3\CMS\Core\Utility\GeneralUtility::getIndpEnv('REQUEST_URI')
			]
		);
		
		$j = 1;
		$content = '';
		$fieldInRow = 'get_default_relation_'.$field.'__method';
		foreach($row[$fieldInRow] as $k => $v){
			
			// editLink
			$editLink = '';
			if($j == 1){
				$editIcon = $obj->iconFactory->getIcon('actions-system-pagemodule-open', \TYPO3\CMS\Core\Imaging\Icon::SIZE_SMALL);
				$editLink = '<td width="29" nowrap style="vertical-align: top; padding:2px;" rowspan="'.count($row[$fieldInRow]).'">
					<a href="'.$backendLink.'" class="btn btn-default btn-sm" style="width: 25px;">
						'.$editIcon.'
					</a>
				</td>';
			}

			$tdContent1 = '-';
			switch($config['AirTable.Class']){
				case 'Litovchenko\AirTable\Field\FalImage':
				case 'Litovchenko\AirTable\Field\FalImages':
					$src = self::FalFilePath($v['get_default_relation_uid_local__method']);
					if(file_exists(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/'.$src) && $src != null){
						$tdContent1 = '<img src="/'.$src.'" style="width: auto; max-width: 200px; border: #ccc 0px solid;">';
					}
				break;
				case 'Litovchenko\AirTable\Field\FalFile':
				case 'Litovchenko\AirTable\Field\FalFiles':
					$src = self::FalFilePath($v['get_default_relation_uid_local__method']);
					if(file_exists(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/'.$src) && $src != null){
						$tdContent1 = $v['get_default_relation_uid_local__method']['name'];
					}
				break;
				case 'Litovchenko\AirTable\Field\FalMix':
				case 'Litovchenko\AirTable\Field\FalMixes':
					$src = self::FalFilePath($v['get_default_relation_uid_local__method']);
					if(file_exists(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/'.$src) && $src != null){
						if($info = getimagesize(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/'.$src)){
							$tdContent1 = '<img src="/'.$src.'" style="width: auto; max-width: 200px; border: #ccc 0px solid;">';
						} else {
							$tdContent1 = $v['get_default_relation_uid_local__method']['name'];
						}
					}
				break;
			}
			
			if($v['deleted'] == 1) {
				$icon = $obj->getIconForRecord('sys_file_reference', $v, \TYPO3\CMS\Core\Imaging\Icon::SIZE_SMALL);
				$content .='
				<tr>
					'.$editLink.'
					<td width="29" nowrap style="vertical-align: top; padding:0; '.HIDE_CHECKBOX.'">
					<div style="position: relative; width: 29px;">
					<label class="btn btn-default btn-sm" style="position: absolute; top: 2px; left: 2px; margin: 0; padding: 0 5px 0 5px; cursor: pointer;">
						<input type="checkbox" class="btn btn-default btn-sm" name="foo_'.$field.'" style="margin-top: 0px;">
					</label>
					</div>
					</td>
					<!--
					<td width="20" nowrap style="'.HIDE_CHECKBOX_TD_NEXT.'">
					<a href="?" class="btn btn-default btn-sm" style="padding-left: 7px; padding-right: 7px;">
						<i class="fa fa-reorder" aria-hidden="true"></i>
					</a>
					</td>
					-->
					<td width="20" nowrap style="vertical-align: top;"><nobr><span style="color_ZZZ: #d45978">'.$icon.' '.$v['uid'].'</span></nobr><!--<br /> '.$j.'/'.count($row[$field]).'--></td>
					<!--<td width="20" nowrap>'.$j.'/'.count($row[$field]).'</td>-->
					<td nowrap><a href="/'.$src.'" target="_blank">'.$tdContent1.'</a></td>
					<!--<td>'.$v['uid_local']['sha1'].'</td>-->
				</tr>';
			} else {
				$icon = $obj->iconFactory->getIconForRecord('sys_file_reference', $v, \TYPO3\CMS\Core\Imaging\Icon::SIZE_SMALL);
				$content .='
				<tr>
					'.$editLink.'
					<td width="29" nowrap style="vertical-align: top; padding:0; '.HIDE_CHECKBOX.'">
					<div style="position: relative; width: 29px;">
					<label class="btn btn-default btn-sm" style="position: absolute; top: 2px; left: 2px; margin: 0; padding: 0 5px 0 5px; cursor: pointer;">
						<input type="checkbox" class="btn btn-default btn-sm" name="foo_'.$field.'" style="margin-top: 0px;">
					</label>
					</div>
					</td>
					<!--
					<td width="20" nowrap style="'.HIDE_CHECKBOX_TD_NEXT.'">
					<a href="?" class="btn btn-default btn-sm" style="padding-left: 7px; padding-right: 7px;">
						<i class="fa fa-reorder" aria-hidden="true"></i>
					</a>
					</td>
					-->
					<td width="20" nowrap style="vertical-align: top;"><nobr><span style="color_ZZZ: #d45978">'.$icon.' '.$v['uid'].'</span></nobr><!--<br /> '.$j.'/'.count($row[$field]).'--></td>
					<!--<td width="20" nowrap>'.$j.'/'.count($row[$field]).'</td>-->
					<td nowrap><a href="/'.$src.'" target="_blank">'.$tdContent1.'</a></td>
					<!--<td>'.$v['uid_local']['sha1'].'</td>-->
				</tr>';
			}
				
			$j++;
		}
		
		if($content == NULL){
			return '<td style="vertical-align: top; padding: 0;">
				<table class="t3tablerel table table-striped table-bordered table-hover" style="margin-top: -1px; margin-bottom: -1px; border: 0;">
				<tr>
					<td width="29" nowrap style="vertical-align: top; padding:0; '.HIDE_CHECKBOX.'">
					<div style="position: relative; width: 29px;">
					<label class="btn btn-default btn-sm" style="position: absolute; top: 2px; left: 2px; margin: 0; padding: 0 5px 0 5px; cursor: pointer;">
						<input type="checkbox" class="btn btn-default btn-sm" name="foo_'.$field.'" style="margin-top: 0px;">
					</label>
					</div>
					</td>
					<td style="'.HIDE_CHECKBOX_TD_NEXT.'"><a href="'.$backendLink.'"><code style="'.STYLE_EMPTY_FIELD.'">Добавить файл</code></a></td>
				</tr>
				</table>
			</td>';
		} else {
			return '<td style="vertical-align: top; padding: 0;">
				<table class="t3tablerel table table-striped table-bordered table-hover" style="margin-top: -1px; margin-bottom: -1px; border: 0;">
				<!--
				<thead>
				<tr>
					<td><b>ID</b></td>
					<td><b>Файл</b></td>
					<td><b>SHA1</b></td>
				</tr>
				</thead>
				-->
				'.$content.'
				</table>
			</td>';
		}
	}
	
	/**
		$rowArray
		[uid] => 1
		[identifier] => /user_upload/records/tt_content/image/FOTO_-_komandy.jpg
		[storage] => Array
        (
            [uid] => 1
            [configuration] => XML
		)
	*/
	public static function FalFilePath($rowArray = [])
	{
		if(isset($rowArray['get_default_relation_storage__method']['configuration'])){
			$xmlArray = \TYPO3\CMS\Core\Utility\GeneralUtility::xml2array($rowArray['get_default_relation_storage__method']['configuration']);
			$storageFile = $xmlArray['data']['sDEF']['lDEF']['basePath']['vDEF'];
			$basenameFile = $rowArray['identifier'];
		} else {
			$storageFile = '';
			$basenameFile = ltrim($rowArray['identifier'],'/');
		}
		$path = str_replace('//','/',$storageFile.$basenameFile);
		return $path;
	}
	
	// Автоматизированная выборка связей 
	public function linkApproach($obj, $class, $field){
		$annotationForeignModel = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignModel');
		$annotationForeignKey = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignKey');
		#return $this->hasMany('Litovchenko\AirTable\Model\SysFileReference', 'uid_foreign', 'uid')
		#	->where('sys_file_reference.tablenames', '=', $class) // BaseUtility::getTableNameFromClass()
		#	->where('sys_file_reference.fieldname', '=', $field)
		#	->orderBy('sys_file_reference.sorting_foreign', 'asc');
		# По имее это тот же самый полиморфизм
		return $obj->morphMany(
			'Litovchenko\AirTable\Model\SysFileReference',
			'getDefaultRelation_'.$field.'_Method',
			'tablenames',
			'uid_foreign',
			'uid'
		)->where('fieldname', '=', $field);
	}
	
	// Создание связей
	public function linkCreate($obj, $class, $field, $idTwo = null, $data = []){} //Todo
	
	// Удаление связей
	public function linkRemove($obj, $class, $field, $idTwo = null, $data = []){} //Todo
}