<?php
namespace Litovchenko\AirTable\Field;
use Litovchenko\AirTable\Field\FalFile;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Field>
 * @AirTable\Parameter\Label:<Изображение>
 */
class FalImage extends FalFile
{	
    /**
     * @return string
     */
    public static function databaseDefinitions($model, $table, $field)
    {
        return [$table=>[
			$field => 'int(11) DEFAULT \'0\' NOT NULL'
		]];
    }
	
    /**
     * @return string
     */
    public static function parameterMinitems($class, $property, $keyAnnotation, $value)
    {
        return $value;
    }
	
    /**
     * @modify array
     */
    public static function buildConfiguration($model, $table, $field)
    {
		$GLOBALS['TCA'][$table]['columns'][$field]['config'] = \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::getFileFieldTCAConfig('',[],'gif,jpg,jpeg,tif,tiff,bmp,pcx,tga,png,pdf,ai,svg','php,php3');
		parent::buildConfiguration($model,$table,$field);
				
		$GLOBALS['TCA'][$table]['columns'][$field]['label'] = $GLOBALS['TCA'][$table]['columns'][$field]['label'];
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['appearance']['headerThumbnail']['width'] = 80;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['appearance']['headerThumbnail']['height'] = 100;
		
		// Минимальное кол-во
		$minitems = BaseUtility::getClassFieldAnnotationValueNew($model,$field,'AirTable\Field\Parameter\Minitems');
		if(!empty($minitems)){
			$GLOBALS['TCA'][$table]['columns'][$field]['config']['minitems'] = $minitems;
		}
		
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['maxitems'] = 1;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['foreign_match_fields'] = [
            'table_local' => 'sys_file',
            'tablenames' => $model,
			'fieldname' => $field,
		];
		
		// Лишнее поле - с ним не получилось записывать не таблицу, а модель
		unset($GLOBALS['TCA'][$table]['columns'][$field]['config']['foreign_table_field']);
		#print "<pre>";
		#print_r($GLOBALS['TCA'][$table]['columns'][$field]);
		#exit();
    }
}