<?php
namespace Litovchenko\AirTable\Field;
use Litovchenko\AirTable\Field\InputNumber;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Field>
 * @AirTable\Parameter\Label:<Число дробное (допускается отрицательное)>
 */
class InputFloat extends InputNumber
{
    /**
     * @return string
     */
    public static function databaseDefinitions($model, $table, $field)
    {
        return [$table=>[
			$field => 'float(2) DEFAULT \'0\' NOT NULL'
		]];
    }

    /**
     * @modify array
     */
    public static function buildConfiguration($model, $table, $field)
    {
		parent::buildConfiguration($model,$table,$field);
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['type'] = 'input';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['eval'] .= ',double2';
    }
}