<?php
namespace Litovchenko\AirTable\Field;
use Litovchenko\AirTable\Field\Input;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Field>
 * @AirTable\Parameter\Label:<Slug-значение>
 */
class InputSlug extends Input
{
    /**
     * @return string
     */
    public static function databaseDefinitions($model, $table, $field)
    {
        return [$table=>[
			$field => 'varchar(2048) DEFAULT \'\' NOT NULL'
		]];
    }
	
    /**
     * @modify array
     */
    public static function buildConfiguration($model, $table, $field)
    {
		parent::buildConfiguration($model,$table,$field);
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['type'] = 'slug';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['eval'] .= ',uniqueInPid';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['fallbackCharacter'] = '-';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['prependSlash'] = true;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['generatorOptions']['fields'] = ['uid','title','alttitle'];
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['generatorOptions']['fieldSeparator'] = '/';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['generatorOptions']['prefixParentPageSlug'] = true;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['generatorOptions']['replacements'] = ['/' => ''];
    }

}
