<?php
namespace Litovchenko\AirTable\Field;
use Litovchenko\AirTable\Field\BaseFieldRelelationRevers;
use Litovchenko\AirTable\Field\Rel_Mto1;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Field>
 * @AirTable\Parameter\Label:<1:M Связь один ко многим (реверс)>
 * @AirTable\Parameter\Description:<Для создания двухсторонней связи>
 */
class Rel_1toM_Revers extends BaseFieldRelelationRevers
{
	const IMPORT = true;
	
    const REQPOSTFIXCURRENTFIELD = '_id';

    const REQPOSTFIXFOREIGNFIELD = '_many';
	
    /**
     * @modify array
     */
    public static function buildConfiguration($model, $table, $field)
    {
		parent::buildConfiguration($model, $table, $field);
		$GLOBALS['TCA'][$table]['columns'][$field]['label'] = $GLOBALS['TCA'][$table]['columns'][$field]['label'].' 1:M';
		if(self::isDoubleRelation($model, $field)){
			$GLOBALS['TCA'][$table]['columns'][$field]['label'] .= '↔';
		}
		$GLOBALS['TCA'][$table]['columns'][$field]['label'] .= ' (Revers)';

		#$_foreignModelName = self::getForeignModelName($model, $field); // foreign model
		#$_foreignTableName = self::getForeignTableName($model, $field); // foreign table
		#$_foreignFieldName = self::getForeignFieldName($model, $field); // foreign key
		
		// $GLOBALS['TCA'][$table]['columns'][$field]['config']['type'] = 'input';
		// $GLOBALS['TCA'][$table]['columns'][$field]['config']['readOnly'] = 1;
		Rel_Mto1::buildConfigurationRelationSelect($model, $table, $field);
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['readOnly'] = 1;
	}
	
	// Автоматизированная выборка связей 
	public function linkApproach($obj, $class, $field){
		$annotationForeignModel = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignModel');
		$annotationForeignKey = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignKey');
		return $obj->belongsTo($annotationForeignModel, $field, 'uid');
	}
	
	// Создание связей
	public function linkCreate($obj, $class, $field, $idTwo = null, $data = []){
		$obj->{$field}()->associate(intval($idTwo)); // belongsTo
		return $obj->save();
	}
	
	// Удаление связей
	public function linkRemove($obj, $class, $field, $idTwo = null, $data = []){
		$obj->{$field}()->dissociate(); // belongsTo
		return $obj->save();
	}

}
