<?php
namespace Litovchenko\AirTable\Field;
use Litovchenko\AirTable\Field\BaseFieldRelelationRevers;
use Litovchenko\AirTable\Field\Rel_1toM;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Field>
 * @AirTable\Parameter\Label:<M:1 Связь многие к одному (реверс)>
 * @AirTable\Parameter\Description:<Для создания двухсторонней связи>
 */
class Rel_Mto1_Revers extends BaseFieldRelelationRevers
{
	const IMPORT = true;
	
    const REQPOSTFIXCURRENTFIELD = '_many';

    const REQPOSTFIXFOREIGNFIELD = '_id';
	
    /**
     * @modify array
     */
    public static function buildConfiguration($model, $table, $field)
    {
		parent::buildConfiguration($model, $table, $field);
		$GLOBALS['TCA'][$table]['columns'][$field]['label'] = $GLOBALS['TCA'][$table]['columns'][$field]['label'].' M:1';
		if(self::isDoubleRelation($model, $field)){
			$GLOBALS['TCA'][$table]['columns'][$field]['label'] .= '↔';
		}
		$GLOBALS['TCA'][$table]['columns'][$field]['label'] .= ' (Revers)';

		$_foreignModelName = self::getForeignModelName($model, $field); // foreign model
		$_foreignTableName = self::getForeignTableName($model, $field); // foreign table
		$_foreignFieldName = self::getForeignFieldName($model, $field); // foreign key
		
		// $GLOBALS['TCA'][$table]['columns'][$field]['config']['type'] = 'input';
		// $GLOBALS['TCA'][$table]['columns'][$field]['config']['readOnly'] = 1;
		Rel_1toM::buildConfigurationRelation($model, $table, $field);
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['readOnly'] = 1;
		unset($GLOBALS['TCA'][$table]['columns'][$field]['config']['minitems']);
		unset($GLOBALS['TCA'][$table]['columns'][$field]['config']['maxitems']);
	}
	
	// Автоматизированная выборка связей 
	public function linkApproach($obj, $class, $field){
		$annotationForeignModel = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignModel');
		$annotationForeignKey = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignKey');
		return $obj->hasMany($annotationForeignModel, $annotationForeignKey, 'uid');
	}
	
	// Создание связей
	public function linkCreate($obj, $class, $field, $idTwo = null, $data = []){
		$field = preg_replace('/_Method$/is','',$field);
		$annotationForeignModel = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignModel');
		$annotationForeignKey = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignKey');
		return $annotationForeignModel::linkCreate($annotationForeignKey.'_Method',$idTwo,$obj->uid);
	}
	
	// Удаление связей
	public function linkRemove($obj, $class, $field, $idTwo = null, $data = []){
		$field = preg_replace('/_Method$/is','',$field);
		$annotationForeignModel = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignModel');
		$annotationForeignKey = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignKey');
		return $annotationForeignModel::linkRemove($annotationForeignKey.'_Method',$idTwo);
	}

}
