<?php
namespace Litovchenko\AirTable\Field;
use Litovchenko\AirTable\Field\BaseFieldRelelationRevers;
use Litovchenko\AirTable\Field\Rel_MtoM;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Field>
 * @AirTable\Parameter\Label:<M:M Связь многие ко многим (реверс)>
 * @AirTable\Parameter\Description:<Для создания двухсторонней связи>
 */
class Rel_MtoM_Revers extends BaseFieldRelelationRevers
{
	const IMPORT = true;
	
    const REQPOSTFIXCURRENTFIELD = '_many';

    const REQPOSTFIXFOREIGNFIELD = '_many';
	
    /**
     * @modify array
     */
    public static function buildConfiguration($model, $table, $field)
    {
		parent::buildConfiguration($model, $table, $field);
		$GLOBALS['TCA'][$table]['columns'][$field]['label'] = $GLOBALS['TCA'][$table]['columns'][$field]['label'].' M:M';
		if(self::isDoubleRelation($model, $field)){
			$GLOBALS['TCA'][$table]['columns'][$field]['label'] .= '↔';
		}
		$GLOBALS['TCA'][$table]['columns'][$field]['label'] .= ' (Revers)';

		$_foreignModelName = self::getForeignModelName($model, $field); // foreign model
		$_foreignTableName = self::getForeignTableName($model, $field); // foreign table
		$_foreignFieldName = self::getForeignFieldName($model, $field); // foreign key
		
		// $GLOBALS['TCA'][$table]['columns'][$field]['config']['type'] = 'input';
		// $GLOBALS['TCA'][$table]['columns'][$field]['config']['readOnly'] = 1;
		Rel_MtoM::buildConfigurationRelationSelect($model, $table, $field);
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['readOnly'] = 1;
		
		if(BaseUtility::hasClassTrait($_foreignModelName,'Litovchenko\AirTable\Field\Traits\RType') == true) {
			if(BaseUtility::hasClassTrait($_foreignModelName,'Litovchenko\AirTable\Field\Traits\Title') == 1){
				$sort = ' ORDER BY RType ASC, title ASC ';
			} else {
				$sort = ' ORDER BY RType ASC, uid ASC ';
			}
		} elseif(BaseUtility::hasClassTrait($_foreignModelName,'Litovchenko\AirTable\Field\Traits\Title') == true) {
			$sort = ' ORDER BY title ASC ';
		} else {
			$sort = ' ORDER BY uid ASC ';
		}
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['foreign_table'] = $_foreignTableName;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['foreign_table_where'] = $sort;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['MM_match_fields']['tablename'] = $_foreignModelName;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['MM_match_fields']['fieldname'] = $_foreignFieldName;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['MM_opposite_field'] = $_foreignFieldName; // Реверс
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['fieldControl']['addRecord']['options']['table'] = $_foreignTableName;
		unset($GLOBALS['TCA'][$table]['columns'][$field]['config']['minitems']);
		unset($GLOBALS['TCA'][$table]['columns'][$field]['config']['maxitems']);
		
		#if($table == 'tx_air_table_examples6_ingredient'){
		#	print "<pre>";
		#	print_r($GLOBALS['TCA'][$table]['columns'][$field]);
		#	exit();
		#}
	}
	
	// Автоматизированная выборка связей 
	public function linkApproach($obj, $class, $field){
		$annotationForeignModel = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignModel');
		$annotationForeignKey = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignKey');
		return $obj->belongsToMany($annotationForeignModel, 'sys_mm', 'uid_foreign', 'uid_local')
			->where('sys_mm.tablename', '=', $annotationForeignModel) // BaseUtility::getTableNameFromClass()
				->where('sys_mm.fieldname', '=', $annotationForeignKey)
					->orderBy('sys_mm.uid_foreign', 'asc');
	}
	
	// Создание связей
	public function linkCreate($obj, $class, $field, $idTwo = null, $data = []){
		$field = preg_replace('/_Method$/is','',$field);
		$annotationForeignModel = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignModel');
		$annotationForeignKey = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignKey');
		
		// belongsToMany
		$arSync = [];
		$indentArray = [
			'tablename' => $annotationForeignModel, 
			'fieldname' => $annotationForeignKey
		];
		#if(is_array($idTwo)){
		#	foreach($idTwo as $k => $id){
		#		$arSync[$id] = $indentArray;
		#		$arSync[$id]['sorting'] = $k;
		#	}
		#} else {
			$arSync[$idTwo] = $indentArray;
			$arSync[$idTwo]['sorting'] = 1;
		#}
		$obj->{$field.'_Method'}()->syncWithoutDetaching($arSync);
		return $obj->save();
	}
	
	// Удаление связей
	public function linkRemove($obj, $class, $field, $idTwo = null, $data = []){
		$field = preg_replace('/_Method$/is','',$field);
		$annotationForeignModel = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignModel');
		$annotationForeignKey = BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\ForeignKey');
		
		// belongsToMany
		$obj->{$field.'_Method'}()
			->wherePivot('tablename', '=', $annotationForeignModel)
				->wherePivot('fieldname', '=', $annotationForeignKey)
					->detach($idTwo); // Если = "0" - удаляеться все связи
		return $obj->save();
	}

}
