<?php
namespace Litovchenko\AirTable\Field;
use Litovchenko\AirTable\Field\BaseField;
use Litovchenko\AirTable\Field\FalFile;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Field>
 * @AirTable\Parameter\Label:<Специальное: информация о файле (FAL)>
 */
class SpecialFalFileInfo extends BaseField
{
    /**
     * @modify array
     */
    public static function buildConfiguration($model, $table, $field)
    {
		parent::buildConfiguration($model, $table, $field);
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['type'] = 'user';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['renderType'] = 'fileInfo';
    }
	
    /**
     * @modify array
     */
    public static function postBuildConfiguration($model, $table, $field)
    {
		#$GLOBALS['TCA'][$table]['ctrl'][''] = '';
	}
	
	// listController func
	public static function listControllerSqlBuilder(&$obj, &$q, $table, $field, $config){
		// $q->addSelect($table.'.'.$field);
		return $q;
	}
	
	// listController func
	public static function listControllerSqlBuilderWith(&$obj, &$q, $table, $field, $config)
	{
		if($table == 'sys_file_metadata'){
			return $q->with('getDefaultRelation_file_Method.getDefaultRelation_storage_Method');
		}
		return $q;
	}
	
	// listController func
	public static function listControllerSqlBuilderOrder(&$obj, $table, $field, $config){
		return false;
	}
	
	// listController func
	public static function listControllerHtmlFilter(&$obj, $table, $field, $config, &$uriBuilder){
		return '-';
	}
	
	// listController func
	public static function listControllerHtmlTh(&$obj, $table, $field, $config){
		return \Litovchenko\AirTable\Field\Input::listControllerHtmlTh($obj, $table, $field, $config);
	}
	
	// listController func
	public static function listControllerHtmlTd(&$obj, $table, $field, $config, $row, &$uriBuilder){
		if($table == 'sys_file_metadata') {
			$fileInfo = $row['get_default_relation_file__method'];
			#if($row['uid'] == 95){
			#	print "<pre>";
			#	print_r($row);
			#	exit();
			#}
		} elseif($table == 'sys_file') {
			$fileInfo = $row;
		}

		//file_exists(PATH_site.$src) && $src != null && 
		$src = FalFile::FalFilePath($fileInfo);
		if(!file_exists(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/'.$src) && $src != null) {
			$tdContent1 = '<a href="/'.$src.'" target="_blank"><code>[? файл отсутствует на сервере]</code></a>';
		} elseif(strstr($fileInfo['mime_type'],'image/')) {
			$tdContent1 = '<a href="/'.$src.'" target="_blank"><img src="/'.$src.'" style="width: auto; max-width: 200px; border: #ccc 0px solid;"></a>';
		} else {
			$tdContent1 = '<a href="/'.$src.'" target="_blank">'.$fileInfo['name'].'</a>';
		}

		return '<td style="vertical-align: top;">'.$tdContent1.'</td>';
	}
}