<?php
namespace Litovchenko\AirTable\Field;
use Litovchenko\AirTable\Field\SwitchInt;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Field>
 * @AirTable\Parameter\Label:<Специальное: тип записи>
 */
class SpecialRType extends SwitchInt
{
    /**
     * @return string
     */
    public static function databaseDefinitions($model, $table, $field)
    {
		#$sql = BaseUtility::getClassAnnotationValueNew($model,'AirTable\Parameter\RType\MySql');
		$userRTypes = $model::baseRTypes();
		foreach($userRTypes as $k => $v){
			if(!ctype_digit($k)){
				return [$table=>[
					$field => 'varchar(255) DEFAULT \'\' NOT NULL'
				]];
			}
		}
		return [$table=>[
			$field => 'smallint UNSIGNED DEFAULT \'0\' NOT NULL'
		]];
		/*
		if(strtolower($sql) == 'varchar'){
			return [$table=>[
				$field => 'varchar(255) DEFAULT \'\' NOT NULL'
			]];
		} elseif(strtolower($sql) == 'int') {
			return [$table=>[
				$field => 'smallint UNSIGNED DEFAULT \'0\' NOT NULL'
			]];
		} else {
		}
		*/
    }
	
    /**
     * @modify array
     */
    public static function buildConfiguration($model, $table, $field)
    {
		parent::buildConfiguration($model, $table, $field);
		$GLOBALS['TCA'][$table]['columns']['RType']['config']['type'] = 'select';
		$GLOBALS['TCA'][$table]['columns']['RType']['config']['renderType'] = 'selectSingle';
		$GLOBALS['TCA'][$table]['columns']['RType']['config']['items'] = [];
		$GLOBALS['TCA'][$table]['columns']['RType']['onChange'] = 'reload';
		unset($GLOBALS['TCA'][$table]['columns']['RType']['config']['default']);
    }
	
    /**
     * @modify array
     */
    public static function postBuildConfiguration($model, $table, $field)
    {
		// Добавляем в название тип элемента (обычно очень актуально при выборе связей в админке)
		$GLOBALS['TCA'][$table]['ctrl']['type'] = 'RType'; // Поле структур
		if(BaseUtility::hasClassTrait($model,'Litovchenko\AirTable\Field\Traits\Title') == true){
			$GLOBALS['TCA'][$table]['ctrl']['label_alt'] = 'RType,uid,title';
		} else {
			$GLOBALS['TCA'][$table]['ctrl']['label_alt'] = 'RType,uid';
		}
		$GLOBALS['TCA'][$table]['ctrl']['label_alt_force'] = 1;
		$GLOBALS['TCA'][$table]['ctrl']['label_userFunc'] = \Litovchenko\AirTable\Field\SpecialRType::class.'->labelSpecialRTypeUserFunction';

		// Добавляем типы
		// $itemDefault = BaseUtility::getClassAnnotationValueNew($model,'AirTable\Parameter\RType\Default');
		// $items = BaseUtility::getClassAnnotationValueNew($model,'AirTable\Parameter\RType\Items');
		$icon = $GLOBALS['TCA'][$table]['ctrl']['typeicon_classes']['default']; // EXT:air_table/Resources/Public/Icons/record.svg
		$userRTypes = $model::baseRTypes();
		
		$items = [];
		foreach($userRTypes as $k => $v){
			if(preg_match('/--div(.*)--/is',$k)){
				$items[] = [
					0 => $v,
					1 => '--div--'
				];
			} else {
				$items[] = [
					0 => $v,
					1 => $k,
					2 => $icon
				];
			}
		}
		
		// $GLOBALS['TCA'][$table]['columns']['RType']['config']['default'] = $itemDefault;
		$GLOBALS['TCA'][$table]['columns']['RType']['config']['items'] = $items;
	}
	
	// Проверка полей связи
	public static function buildConfigurationCheck($model, $table, $field)
	{
		// Список ошибок
		$arError = parent::buildConfigurationCheck($model, $table, $field);
		
		#$sql = BaseUtility::getClassAnnotationValueNew($model,'AirTable\Parameter\RType\MySql');
		#if($sql == ''){
		#	$arError[] = '<li>Не определен обязательный параметр <code>"@AirTable\Parameter\RType\MySql:"</code>.
		#	Допустипые значений <code>int||varchar</code></li>';
		#}
		
		#$itemDefault = BaseUtility::getClassAnnotationValueNew($model,'AirTable\Parameter\RType\Default');
		#if($itemDefault == ''){
		#	$arError[] = '<li>Не определен обязательный параметр <code>"@AirTable\Parameter\RType\Default:"</code></li>';
		#}
		
		#$items = BaseUtility::getClassAnnotationValueNew($model,'AirTable\Parameter\RType\Items');
		#if(empty($items)){
		#	$arError[] = '<li>Обязательный параметр <code>"@AirTable\Parameter\RType\Items:"</code> 
		#	не содержит определений о типах записей данной таблицы</li>';
		#}
		
		return $arError;
	}
	
	// Функция выводить альтернативное название для записей с типом поля RType
	public static function labelSpecialRTypeUserFunction(&$parameters)
	{
		if(is_array($parameters['row']['RType'])){
			$temp = BaseUtility::getTcaFieldItem($parameters['table'],'RType',$parameters['row']['RType'][0]);
			$newTitle = '[Тип: '.$temp[0].'] ';
		} else {
			$temp = BaseUtility::getTcaFieldItem($parameters['table'],'RType',$parameters['row']['RType']);
			$newTitle = '[Тип: '.$temp[0].'] ';
		}
		if($parameters['row']['title'] != ''){
			$newTitle .= $parameters['row']['title'];
		} else {
			$newTitle .= $parameters['row']['uid'];
		}
		$parameters['title'] = $newTitle;
	}
}