<?php
namespace Litovchenko\AirTable\Field;
use Litovchenko\AirTable\Field\Input;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Field>
 * @AirTable\Parameter\Label:<Многострочный текст>
 */
class Text extends Input
{
    /**
     * @return string
     */
    public static function databaseDefinitions($model, $table, $field)
    {
        return [$table=>[
			$field => 'text'
		]];
    }
	
    /**
     * @return string
     */
    public static function parameterPlaceholder($class, $property, $keyAnnotation, $value)
    {
        return $value;
    }
	
    /**
     * @return string
     */
    public static function parameterLiveSearch($class, $property, $keyAnnotation, $value)
    {
        return $value;
    }
	
    /**
     * @modify array
     */
    public static function buildConfiguration($model, $table, $field)
    {
		parent::buildConfiguration($model,$table,$field);
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['type'] = 'text';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['eval'] .= '';
		
		// Значение по умолчанию
		$default = BaseUtility::getClassFieldAnnotationValueNew($model,$field,'AirTable\Field\Parameter\Default');
		if(!empty($default)){
			$GLOBALS['TCA'][$table]['columns'][$field]['config']['default'] = $default;
		}
	}
	
	// listController func
	public static function listControllerHtmlTd(&$obj, $table, $field, $config, $row, &$uriBuilder){
		$backendLink = \TYPO3\CMS\Backend\Utility\BackendUtility::getModuleUrl(
			'record_edit', [
				'columnsOnly' => $field,
				'edit['.$table.']['.$row['uid'].']' => 'edit',
				'returnUrl' => \TYPO3\CMS\Core\Utility\GeneralUtility::getIndpEnv('REQUEST_URI')
			]
		);
		if($row[$field] == NULL){
			$rowValue = '<code style="'.STYLE_EMPTY_FIELD.'">Заполнить</code>';
		} else {
			$rowValue = nl2br(htmlspecialchars($row[$field]));
		}
		return '<td style="vertical-align: top;"><a href="'.$backendLink.'">'.$rowValue.'</a></td>';
	}
}
