<?php
namespace Litovchenko\AirTable\Field;
use Litovchenko\AirTable\Field\Text;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Field>
 * @AirTable\Parameter\Label:<Многострочный текст (программный код)>
 */
class TextCode extends Text
{
    /**
     * @var string
     */
    protected $format;
	
    /**
     * @return string
     */
    public static function parameterFormat($class, $property, $keyAnnotation, $value)
    {
        return $value;
    }

    /**
     * @modify array
     */
    public static function buildConfiguration($model, $table, $field)
    {
		parent::buildConfiguration($model,$table,$field);
		$format = BaseUtility::getClassFieldAnnotationValueNew($model,$field,'AirTable\Field\Parameter\Format');
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['type'] = 'text';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['renderType'] = 't3editor';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['format'] = $format; // "mixed" not work in v9!?
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['eval'] .= '';
    }
}
