<?php
namespace Litovchenko\AirTable\Field;
use Litovchenko\AirTable\Field\BaseField;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Field>
 * @AirTable\Parameter\Label:<Файл>
 */
class UploadFile extends BaseField
{
	const EXPORT = false;
	
	const IMPORT = false;
	
    /**
     * @return string
     */
    public static function databaseDefinitions($model, $table, $field)
    {
        return [$table=>[
			$field => 'varchar(255) DEFAULT \'\' NOT NULL'
		]];
    }

    /**
     * @modify array
     */
    public static function buildConfiguration($model, $table, $field)
    {
		parent::buildConfiguration($model,$table,$field);
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['type'] = 'group';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['internal_type'] = 'file';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['show_thumbs'] = 1;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['allowed'] = '*';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['disallowed'] = 'php,php3';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['max_size'] = 10000000;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['maxitems'] = 1;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['size'] = 1;
        $GLOBALS['TCA'][$table]['columns'][$field]['config']['uploadfolder'] = 'uploads/media/'.$table.'/'.$field.'/';
		\TYPO3\CMS\Core\Utility\GeneralUtility::mkdir(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/uploads/media/'.$table.'/');
		\TYPO3\CMS\Core\Utility\GeneralUtility::mkdir(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/uploads/media/'.$table.'/'.$field.'/');
    }
	
	// listController func
	#public static function listControllerSqlBuilder(&$obj, &$q, $table, $field, $config){
	#}
	
	// listController func
	#public static function listControllerSqlBuilderOrder(){
	#	return false;
	#}
	
	// listController func
	#public static function listControllerHtmlFilter(&$obj, $table, $field, $config){
	#}
	
	// listController func
	public static function listControllerHtmlTh(&$obj, $table, $field, $config){
		return \Litovchenko\AirTable\Field\Input::listControllerHtmlTh($obj, $table, $field, $config);
	}
	
	// listController func
	public static function listControllerHtmlTd(&$obj, $table, $field, $config, $row, &$uriBuilder){
		$backendLink = \TYPO3\CMS\Backend\Utility\BackendUtility::getModuleUrl(
			'record_edit', [
				'columnsOnly' => $field,
				'edit['.$table.']['.$row['uid'].']' => 'edit',
				'returnUrl' => \TYPO3\CMS\Core\Utility\GeneralUtility::getIndpEnv('REQUEST_URI')
			]
		);
		
		$j = 1;
		$content = '';
		$fileFolder = $config['config']['uploadfolder'];
		$files = explode(',',$row[$field]);
		foreach($files as $k => $v){
			
			// editLink
			$editLink = '';
			if($j == 1){
				$editIcon = $obj->iconFactory->getIcon('actions-system-pagemodule-open', \TYPO3\CMS\Core\Imaging\Icon::SIZE_SMALL);
				$editLink = '<td width="29" nowrap style="vertical-align: top; padding:2px;" rowspan="'.count($files).'">
					<a href="'.$backendLink.'" class="btn btn-default btn-sm" style="width: 25px;">
						'.$editIcon.'
					</a>
				</td>';
			}

			$tdContent1 = '-';
			switch($config['AirTable.Class']){
				case 'Litovchenko\AirTable\Field\UploadImage':
				case 'Litovchenko\AirTable\Field\UploadImages':
					if(file_exists(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/'.$fileFolder.$v) && $v != null){
						$tdContent1 = '<img src="/'.$fileFolder.$v.'" style="width: auto; max-width: 200px; border: #ccc 0px solid;">';
					}
					$content .='
					<tr>
						'.$editLink.'
						<!--<td width="20" nowrap>'.$j.'/'.count($files).'</td>-->
						<td nowrap><a href="/'.$fileFolder.$v.'" target="_blank">'.$tdContent1.'</a></td>
						<!--<td>'.$v.'</td>-->
					</tr>';

				break;
				case 'Litovchenko\AirTable\Field\UploadFile':
				case 'Litovchenko\AirTable\Field\UploadFiles':
					if(file_exists(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/'.$fileFolder.$v) && $v != null){
						$tdContent1 = $v;
					}
					$content .='
					<tr>
						'.$editLink.'
						<!--<td width="20" nowrap>'.$j.'/'.count($files).'</td>-->
						<td nowrap><a href="/'.$fileFolder.$v.'" target="_blank">'.$tdContent1.'</a></td>
					</tr>';
				break;
			}
				
			$j++;
		}
		
		if(empty($files[0])){
			return '<td nowrap style="vertical-align: top;"><a href="'.$backendLink.'"><code style="'.STYLE_EMPTY_FIELD.'">Прикрепить файл</code></a></td>';
		} else  {
			return '<td style="vertical-align: top; padding: 0;">
				<table class="t3tablerel table table-striped table-bordered table-hover" style="margin-top: -1px; margin-bottom: -1px; border: 0;">
				<thead>
				<tr>
					<!--<td><b>№</b></td>-->
					<!--<td><b>Файл</b></td>-->
				</tr>
				</thead>
				'.$content.'
				</table>
			</td>';
		}
	}
}
