<?php
namespace Litovchenko\AirTable\Field;
use Litovchenko\AirTable\Field\Input;
use Litovchenko\AirTable\Utility\BaseUtility;

/**
 * @AirTable:<Field>
 * @AirTable\Parameter\Label:<Год>
 */
class Year extends Input
{	
    /**
     * @return string
     */
    public static function databaseDefinitions($model, $table, $field)
    {
        return [$table=>[
			$field => 'int(11) DEFAULT \'0\' NOT NULL'
		]];
    }

    /**
     * @modify array
     */
    public static function buildConfiguration($model, $table, $field)
    {
		parent::buildConfiguration($model,$table,$field);
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['type'] = 'input';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['eval'] = 'year';
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['min'] = 4;
		$GLOBALS['TCA'][$table]['columns'][$field]['config']['max'] = 4;
    }
	
	// listController func
	public static function listControllerSqlBuilder(&$obj, &$q, $table, $field, $config){
		return \Litovchenko\AirTable\Field\Date::listControllerSqlBuilder($obj, $q, $table, $field, $config);
	}
	
	// listController func
	public static function listControllerSqlBuilderOrder(){
		return true;
	}
	
	// listController func
	public static function listControllerHtmlFilter(&$obj, $table, $field, $config, &$uriBuilder){
		return \Litovchenko\AirTable\Field\Date::listControllerHtmlFilter($obj, $table, $field, $config, $uriBuilder);
	}
	
	// listController func
	public static function listControllerHtmlTh(&$obj, $table, $field, $config){
		return \Litovchenko\AirTable\Field\Date::listControllerHtmlTh($obj, $table, $field, $config);
	}
	
	// listController func
	public static function listControllerHtmlTd(&$obj, $table, $field, $config, $row, &$uriBuilder){
		return \Litovchenko\AirTable\Field\Date::listControllerHtmlTd($obj, $table, $field, $config, $row, $uriBuilder);
	}
}
