<?php
namespace Litovchenko\AirTable\Hooks;

use TYPO3\CMS\Core\Configuration\ExtensionConfiguration;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Object\ObjectManager;
use Litovchenko\AirTable\Utility\BaseUtility;

class DatabaseSchemaService
{
    /**
     * A slot method to inject the required mysql fulltext definition
     * to schema migration
     *
     * @param array $sqlString
     * @return array
     */
    public function addMysqlTableAndFields(array $sqlString)
    {
		$fields = [];
		$models = BaseUtility::getLoaderClasses('Classes/Domain/');
		foreach($models as $class) {
			$class_parents = class_parents($class);
			if(in_array('Litovchenko\AirTable\Model\Base',$class_parents) && BaseUtility::getClassAnnotationValueNew($class,'AirTable') == 'Table'){
				$table = BaseUtility::getTableNameFromClass($class);
				
				//$fields = [];
				//$fields[] = 'sys_export int(11) DEFAULT \'0\' NOT NULL'; // Добавил для колонки заглушки для "Analyze Database Structure" 
				//$fields[] = 'sys_import int(11) DEFAULT \'0\' NOT NULL'; // Добавил для колонки заглушки для "Analyze Database Structure" 
				
				$userFields = BaseUtility::getClassAllFieldsNew($class);
				foreach($userFields as $kField => $vField){
					$annotationField = BaseUtility::getClassFieldAnnotationValueNew($class,$vField,'AirTable\Field');
					$annotationDoNotCheck = BaseUtility::getClassFieldAnnotationValueNew($class,$vField,'AirTable\Field\Parameter\DoNotCheck');
					$annotationDoNotSqlAnalyze = BaseUtility::getClassFieldAnnotationValueNew($class,$vField,'AirTable\Field\Parameter\DoNotSqlAnalyze');
					$fieldClass = 'Litovchenko\AirTable\Field\\'.$annotationField;
					if(class_exists($fieldClass) && method_exists($fieldClass,'buildConfiguration') && method_exists($fieldClass,'buildConfigurationCheck')){
						// Делаем проверку
						$arError = $fieldClass::buildConfigurationCheck($class,$table,$vField);
						if(count($arError) == 0 || $annotationDoNotCheck == 1){
							// Выбираем данные о MySql поле
							if(method_exists($fieldClass, 'databaseDefinitions')){
								$databaseDefinitionsAr = $fieldClass::databaseDefinitions($class,$table,$vField);
								foreach($databaseDefinitionsAr as $tName => $fAr){
									foreach($fAr as $fK => $fV){
										// Таким образом исключаем возможности ошибок (в основном от полей со связями в которые есть ошибки про создании) 
										if(trim($tName) != '' && trim($fK) != '' && trim($fV) != ''){
											#if($fK == 'uid'){
											#	continue;
											#}
											#if($fK == 'pid'){
											#	continue;
											#}
											#if($fK == 'importprocess'){
											#	continue;
											#}
											#if($fK == 'importolduid'){
											#	continue;
											#}
											if($annotationDoNotSqlAnalyze == 1){
												continue;
											}
											$fields[$tName][$fK] = "\t".$fK." ".$fV; // 'test int(11) DEFAULT \'0\' NOT NULL'
										}
									}
								}
							}
						}
					}
				}
			}
		}
				
		// $sqlString[] = LF . 'CREATE TABLE ' . $table . ' (' . LF . \implode(',' . LF, $fields) . LF . ');' . LF;
		$extPath = \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('air_table');
		$virgule = ',';
		foreach($models as $class) {
			$class_parents = class_parents($class);
			if(in_array('Litovchenko\AirTable\Model\Base',$class_parents) && BaseUtility::getClassAnnotationValueNew($class,'AirTable') == 'Table'){
				$table = BaseUtility::getTableNameFromClass($class);
				if($table == 'sys_mm'){
					$sqlContent = file_get_contents($extPath.'Resources/Private/SqlSysMm.sql');
					$virgule = ',';
					
				} elseif(in_array('Litovchenko\AirTable\Model\BaseCrud2',$class_parents)) {
					$sqlContent = file_get_contents($extPath.'Resources/Private/SqlBaseCrud2.sql');
					$virgule = '';
					
				} elseif(in_array('Litovchenko\AirTable\Model\BaseCrud',$class_parents)) {
					$sqlContent = file_get_contents($extPath.'Resources/Private/SqlBaseCrud.sql');
					$virgule = ',';
					
				} else {
					
				}
				
				$sqlContent = str_replace('###TABLE###', $table, $sqlContent);
				if(count($fields[$table])>0){
					$send = str_replace("###COLUMNS###", implode(",\n", $fields[$table]).$virgule, $sqlContent);
					$sqlString[$table.'_AirTableSql'] = $send;
				} else {
					$send = str_replace("###COLUMNS###", "", $sqlContent);
					$sqlString[$table.'_AirTableSql'] = $send;
				}
			}
		}

		// BaseUtility::fileReWrite(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/1.txt',print_r($fields,true));
		BaseUtility::fileReWrite(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/typo3temp/ext_tables.sql',print_r($sqlString,true));
        return [$sqlString];
    }
}
