<?php
namespace Litovchenko\AirTable\Hooks;

use TYPO3\CMS\Core\Core\Bootstrap;
use TYPO3\CMS\Core\Database\TableConfigurationPostProcessingHookInterface;
use TYPO3\CMS\Core\Utility\ExtensionManagementUtility;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Reflection\ObjectAccess;
use TYPO3\CMS\Extbase\Reflection\ClassSchema;
use Litovchenko\AirTable\Utility\BaseUtility;

class TableConfigurationPostProcessor implements TableConfigurationPostProcessingHookInterface
{
    public function processData()
    {
        if (TYPO3_REQUESTTYPE_INSTALL !== (TYPO3_REQUESTTYPE & TYPO3_REQUESTTYPE_INSTALL)) {
			// Генерируем TCA
			$models = BaseUtility::getLoaderClasses('Classes/Domain/');
			foreach($models as $class) {
				$class_parents = class_parents($class);
				
				// Регистрация новых пользовательских моделей
				// 'Illuminate\Database\Eloquent\Model'
				if(in_array('Litovchenko\AirTable\Model\BaseCrud',$class_parents) && BaseUtility::getClassAnnotationValueNew($class,'AirTable') == 'Table'){
					$table = BaseUtility::getTableNameFromClass($class);
					$this->generateTableConfiguration($class, $table);
				}
				
				// Регистрация моделей на основе существующей таблицы TYPO3
				if(in_array('Litovchenko\AirTable\Model\BaseCrud2',$class_parents) && BaseUtility::getClassAnnotationValueNew($class,'AirTable') == 'Table'){
					$table = BaseUtility::getTableNameFromClass($class);
					$this->registrationTableConfiguration($class, $table);
				}
				
				// [Отказался - нет даже модели Pagesъ
				// Регистрация моделей на основе существующей таблицы TYPO3
				// 'TYPO3\CMS\Extbase\DomainObject\AbstractEntity'
				// 'TYPO3\CMS\Extbase\DomainObject\AbstractValueObject'
				// Создаем файлы BaseCrud2
				#if(in_array('TYPO3\CMS\Extbase\DomainObject\AbstractEntity',$class_parents)
				#	|| in_array('TYPO3\CMS\Extbase\DomainObject\AbstractValueObject',$class_parents)){
				#	$r = new \ReflectionClass($class);
				#	if(!$r->isAbstract()){
				#		// table name
				#		$objectManager = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Extbase\Object\ObjectManager::class);
				#		$dataMapper = $objectManager->get(\TYPO3\CMS\Extbase\Persistence\Generic\Mapper\DataMapper::class);
				#		$table = $dataMapper->getDataMap($class)->getTableName();
				#		
				#		// file BaseCrud2
				#		if(isset($GLOBALS['TCA'][$table])){
				#			$path_Typo3ExtAirTable = \TYPO3\CMS\Core\Core\Environment::getExtensionsPath().'/air_table/Resources/Private/BaseCrudEntity.txt';
				#			$content = file_get_contents($path_Typo3ExtAirTable);
				#			$content = str_replace(
				#				[
				#					'###NAMESPACE-NAME###',
				#					'###MODEL-NAME###',
				#					'###TABLE-NAME###',
				#					'###TABLE-KEY###',
				#					''
				#				],
				#				[
				#					$r->getNamespaceName(),
				#					'_Laravel'.$r->getShortName(),
				#					'--auto--',
				#					$table
				#				],
				#				$content
				#			);
				#			
				#			$classDirPath = BaseUtility::getClassDirPath($class);
				#			BaseUtility::fileReWrite($classDirPath.'_Laravel'.$r->getShortName().'.php',$content);
				#		}
				#	}
				#}
			}
			
			// Вызываем событие после обработки моделей (для колонок)
			foreach($models as $class) {
				$class_parents = class_parents($class);
				if(in_array('Litovchenko\AirTable\Model\Base',$class_parents) && BaseUtility::getClassAnnotationValueNew($class,'AirTable') == 'Table'){
					$table = BaseUtility::getTableNameFromClass($class);
					$userFields = BaseUtility::getClassAllFieldsNew($class);
					foreach($userFields as $kField => $vField){
						$annotationField = BaseUtility::getClassFieldAnnotationValueNew($class,$vField,'AirTable\Field');
						$fieldClass = 'Litovchenko\AirTable\Field\\'.$annotationField;
						if(class_exists($fieldClass) && method_exists($fieldClass,'postBuildConfiguration')) {
							$fieldClass::postBuildConfiguration($class,$table,$vField);
						}
					}
				}
			}
			
			// Вызываем событие после обработки моделей
			foreach($models as $class) {
				$class_parents = class_parents($class);
				if(in_array('Litovchenko\AirTable\Model\Base',$class_parents) && BaseUtility::getClassAnnotationValueNew($class,'AirTable') == 'Table'){
					if (method_exists($class,'postBuildConfiguration')){
						$table = BaseUtility::getTableNameFromClass($class);
						$init = $class::postBuildConfiguration($GLOBALS['TCA'][$table]);
					}
				}
			}
        }
    }
	
	protected function exTableConfiguration($class, $table)
    {
		#$classNameParentModel = current(explode('_Ex_',$className));
		#$fromExtension = end(explode('_Ex_',$className));
		#$class_vars = BaseFunction::get_class_TYPO3_vars($className);
		#$this->reportCompilation[] = 'Расширение сущесвтующей таблицы - ' . $className;
		
		// Проверка загруженности расширения
		//if(!\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::isLoaded($fromExtension)){
		//	continue;
		//}
		/*
			// проверяем сущестование таблицы
			if(!class_exists($classNameParentModel)){
				BaseFunction::ServiceUnavailableException($className, "
					Для класса с расширения полей (EX) не существует базовой модели для расширения (\"".$classNameParentModel."\")
				");
			}elseif($fromExtension != $class_vars['ext']){
				BaseFunction::ServiceUnavailableException($className, "
					В названии класса (\"".$classNameParentModel."\") с расширения полей (EX) не задан постфикс расширения (\"".$class_vars['ext']."\")
				");
			} else {
				// если это не новая таблица - сообщаем, что таблица прошла модификацию (добавление полей)
				// и ее нужно выгрузить в ext_tables.sql
				// t3lib_div::loadTCA($class_vars['table_without_prefix_and_ex']);
				$GLOBALS['TCA'][$class_vars['table_without_prefix_and_ex']]['ctrl']['AirTableEx'] = 1;
				$GLOBALS['TCA'][$class_vars['table_without_prefix_and_ex']]['ctrl']['AirTableModelEx'][] = $className;
				$GLOBALS['TCA'][$class_vars['table_without_prefix_and_ex']]['ctrl']['AirTableModelEx_path'][] = $class_vars['file_path'];
			}
		*/
		
		BaseFunction::ServiceUnavailableException($className, "Добавляемая в структуру ($k_addFieldsToTCAtypes) колонка ($v) не существует");
		BaseFunction::ServiceUnavailableException($className, "Указанная структура ($k_addFieldsToTCAtypes) в \"TYPO3_addFieldsToTCAtypes\" не существует");
		BaseFunction::ServiceUnavailableException($className, "Добавляемая в группу ($k_addFieldsToTCApalettes) колонка ($v) не существует");
		BaseFunction::ServiceUnavailableException($className, "Указанная группа ($k_addFieldsToTCApalettes) в \"TYPO3_addFieldsToTCApalettes\" не существует");
		// \TYPO3\CMS\Extbase\Utility\DebuggerUtility::var_dump(array(1=>432));
	}
	
	protected function registrationTableConfiguration($class, $table)
    {
		// Если таблица не существует - пропускаем
		if(empty($GLOBALS['TCA'][$table])){
			return false;
		}
		
		// Если создается не из расширения EXT:air_table
		if(BaseUtility::getExtNameFromClassPath($class) != 'air_table'){
			return false;
		}
		
		// TCA, помеченный как AirTable
		$GLOBALS['TCA'][$table]['ctrl']['AirTable.Class'] = $class;
		$GLOBALS['TCA'][$table]['ctrl']['AirTable.Ext'] = BaseUtility::getExtNameFromClassPath($class);
		$GLOBALS['TCA'][$table]['ctrl']['AirTable.SubDomain'] = BaseUtility::getSubDomainNameFromClassPath($class);
		// $GLOBALS['TCA'][$table]['ctrl']['rootLevel'] = -1;
		
		// Генерируем пользовательские колонки
		$userFields = BaseUtility::getClassAllFieldsNew($class);
		foreach($userFields as $kField => $vField){
			$annotationField 		= BaseUtility::getClassFieldAnnotationValueNew($class,$vField,'AirTable\Field');
			$annotationLabel 		= BaseUtility::getClassFieldAnnotationValueNew($class,$vField,'AirTable\Field\Parameter\Label');
			$annotationMethod 		= BaseUtility::getClassFieldAnnotationValueNew($class,$vField,'AirTable\Field\Parameter\Method');
			$annotationDoNotCheck 	= BaseUtility::getClassFieldAnnotationValueNew($class,$vField,'AirTable\Field\Parameter\DoNotCheck');
		
			if(empty($GLOBALS['TCA'][$table]['columns'][$vField])){
				// Проверка на наличие префикса
				$requiredPrefix = 'ex_'.BaseUtility::getExtNameFromClassPath($class).'_';
				if(!preg_match('/^'.$requiredPrefix.'/is',$vField,$match) && $annotationDoNotCheck != 1){
					$GLOBALS['TCA'][$table]['columns'][$vField]['label'] = $annotationLabel;
					$GLOBALS['TCA'][$table]['columns'][$vField]['config'] = [
						'type' => 'user',
						'userFunc' => 'Litovchenko\AirTable\Field\BaseField->fieldErrorDisplay',
						'parameters' => [
							'message' => [0=>'<li>Отсутствует обязательный префикс 
							<code>"' . $requiredPrefix . '"</code> в названии колонки 
							указывающий на принадлежность к расширению</li>']
						]
					];
					$this->registrationFieldInForm($class, $table, $vField);
				} else {
					$this->registrationFieldConfiguration($class, $table, $vField);
					$this->registrationFieldInForm($class, $table, $vField);
				}
			} else {
				$fieldClass = 'Litovchenko\AirTable\Field\\'.$annotationField;
				$GLOBALS['TCA'][$table]['columns'][$vField]['AirTable.Class'] = $fieldClass;
				$GLOBALS['TCA'][$table]['columns'][$vField]['AirTable.MySql'] = $fieldClass::databaseDefinitions($class, $table, $vField);
				if(!empty($annotationLabel)){
					$GLOBALS['TCA'][$table]['columns'][$vField]['label'] = $annotationLabel;
				}
			}
		}
	}
	
    protected function generateTableConfiguration($class, $table)
    {
		// Создание массива TCA, помеченного как AirTable
		$GLOBALS['TCA'][$table] = [];
		$GLOBALS['TCA'][$table]['columns'] = [];
		$GLOBALS['TCA'][$table]['ctrl'] = [];
		$GLOBALS['TCA'][$table]['ctrl']['AirTable.Class'] = $class;
		$GLOBALS['TCA'][$table]['ctrl']['AirTable.Ext'] = BaseUtility::getExtNameFromClassPath($class);
		$GLOBALS['TCA'][$table]['ctrl']['AirTable.SubDomain'] = BaseUtility::getSubDomainNameFromClassPath($class);
		// $GLOBALS['TCA'][$table]['ctrl']['security']['ignoreRootLevelRestriction'] = true; // Access
		// $GLOBALS['TCA'][$table]['ctrl']['security']['ignoreWebMountRestriction'] = true; // Access
		$GLOBALS['TCA'][$table]['ctrl']['label'] = "uid"; // Поля заголовка (для списка)
		$GLOBALS['TCA'][$table]['ctrl']['title'] = BaseUtility::getClassAnnotationValueNew($class,'AirTable\Parameter\Label'); // название записываем в xml, что бы при выборе через модуль список правильно проходила группировка в "/typo3/db_new.php"
		if(BaseUtility::hasClassTrait($class,'Litovchenko\AirTable\Field\Traits\BeUserId') == true) {
			$GLOBALS['TCA'][$table]['ctrl']['cruser_id'] = 'be_users_id';
		}
		if($table == 'sys_mm'){
			$GLOBALS['TCA'][$table]['ctrl']['groupName'] = 0;
		} else {
			$GLOBALS['TCA'][$table]['ctrl']['groupName'] = BaseUtility::getExtNameFromClassPath($class);
		}

		// Поиск в админке по хештегу "#"
		$LiveSearchHashTagKey = BaseUtility::getClassAnnotationValueNew($class,'AirTable\Parameter\LiveSearchHashTagKey');
		if($LiveSearchHashTagKey != '' && empty($GLOBALS['TYPO3_CONF_VARS']['SYS']['livesearch'][$LiveSearchHashTagKey])){
			$livekey = BaseUtility::getExtNameFromClassPath($class);
			$livekey .= $LiveSearchHashTagKey;
			$GLOBALS['TYPO3_CONF_VARS']['SYS']['livesearch'][$livekey] = $table;
		}
		
		// Возможность размещять записи в любом месте дерева страниц
		if(BaseUtility::getClassAnnotationValueNew($class,'AirTable\Parameter\PidAny') == 1){
			\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::allowTableOnStandardPages($table);
			$GLOBALS['TCA'][$table]['ctrl']['hideTable'] = 0;
			$GLOBALS['TCA'][$table]['ctrl']['rootLevel'] = -1;
		} else {
			$GLOBALS['TCA'][$table]['ctrl']['hideTable'] = 0;
			$GLOBALS['TCA'][$table]['ctrl']['rootLevel'] = 1;
		}
		
		// Иконка
		if(BaseUtility::isModelCategoryForAnotherModel($class)){
			$GLOBALS['TCA'][$table]['ctrl']['typeicon_classes']['default'] = 'extensions-air_table-icon_' . $table;	
			$iconRegistry = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Imaging\IconRegistry::class);
			$iconRegistry->registerIcon(
			   'extensions-air_table-icon_' . $table, // Icon-Identifier, z.B. tx-myext-action-preview
			   \TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
			   ['source' => 'EXT:air_table/Resources/Public/Icons/record.category.svg']
			);
		} else {
			$GLOBALS['TCA'][$table]['ctrl']['typeicon_classes']['default'] = 'extensions-air_table-icon_' . $table;	
			$iconRegistry = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Imaging\IconRegistry::class);
			$iconRegistry->registerIcon(
			   'extensions-air_table-icon_' . $table, // Icon-Identifier, z.B. tx-myext-action-preview
			   \TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
			   ['source' => 'EXT:air_table/Resources/Public/Icons/record.svg']
			);
		}
		
		// Если мультиструктуры
		if(BaseUtility::hasClassTrait($class,'Litovchenko\AirTable\Field\Traits\RType') == true) {
			$this->registrationRTypeConfiguration($class, $table, 0); // Базовая структура
			$userRTypes = $class::baseRTypes();
			foreach($userRTypes as $k => $v){
				$this->registrationRTypeConfiguration($class, $table, $k); // Пользовательская структура
			}
		
		// Без мультиструктур
		} else {
			$this->registrationRTypeConfiguration($class, $table, 0); // Базовая структура
		}
		
		// Генерируем пользовательские колонки
		$userFields = BaseUtility::getClassAllFieldsNew($class);
		foreach($userFields as $kfield => $field){
			$this->registrationFieldConfiguration($class, $table, $field);
			$this->registrationFieldInForm($class, $table, $field);
		}
		
		// Вставляем кол-во свойств на вкладку "Свойства (###COUNT###)"
		foreach($GLOBALS['TCA'][$table]['types'] as $kType => $vType){
			$fieldsInType = BaseUtility::getAllColumnsFromType($table,$kType);
			$temp = explode("\n",$GLOBALS['TCA'][$table]['types'][$kType]['showitem']);
			foreach($temp as $k => $v){
				$fieldCounter = substr_count(preg_replace('/,$/is','',$v),',')-2;
				$temp[$k] = str_replace('###COUNT###',$fieldCounter,$temp[$k]);
			}
			$GLOBALS['TCA'][$table]['types'][$kType]['showitem'] = implode("\n",$temp);
		}
		
		// Палетты (на данном этапе пока решил отказаться от них!)
		#$GLOBALS['TCA'][$table]['palettes'] = [];
		#$GLOBALS['TCA'][$table]['palettes']['index']['showitem'] = 'title, RType, uid, --linebreak--, alttitle';
		#$GLOBALS['TCA'][$table]['palettes']['index']['canNotCollapse'] = 0;
		#$GLOBALS['TCA'][$table]['palettes']['metatags']['showitem'] = 'vp_path_segment, --linebreak--, vp_keywords, vp_description';
		#$GLOBALS['TCA'][$table]['palettes']['metatags']['canNotCollapse'] = 0;
		#$GLOBALS['TCA'][$table]['palettes']['time']['showitem'] = 'date_create, date_update, date_start, date_end';
		#$GLOBALS['TCA'][$table]['palettes']['time']['canNotCollapse'] = 0;
    }
	
	protected function registrationRTypeConfiguration($class, $table, $type = 0)
    {
		// Данные из класса
		$userRTypes = $class::baseRTypes();
		$userTabs = $class::baseTabs();
		
		// Табы для структуры по умолчанию
		$tabs = [];
		foreach($userTabs as $k => $tab){
			$tabLabel = $tab;
			if($GLOBALS['TYPO3_CONF_VARS']['BE']['debug'] == true){
				$tabLabel .= ' ['.$k.']';
			}
			$tabs[$k] = 'tab_'.$k.'_start,--div--;'.$tabLabel.',tab_'.$k.'_end';
		}
		$GLOBALS['TCA'][$table]['types'][$type]['showitem'] = implode(",\n",$tabs);
	}
	
	protected function registrationFieldConfiguration($class, $table, $field)
    {
		$annotationField 		= BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field');
		$annotationMethod 		= BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\Method'); // BaseCrud2
		$annotationLabel		= BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\Label');
		$annotationDoNotCheck 	= BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\DoNotCheck');
		
		// Генерируем колонку и ее настройки
		$fieldClass = 'Litovchenko\AirTable\Field\\'.$annotationField;
		if(class_exists($fieldClass)) { // && method_exists($fieldClass,'buildConfiguration')
			$arError = $fieldClass::buildConfigurationCheck($class,$table,$field);
			if(count($arError)>0 && $annotationDoNotCheck != 1){
				$GLOBALS['TCA'][$table]['columns'][$field]['label'] = $annotationLabel;
				$GLOBALS['TCA'][$table]['columns'][$field]['config'] = [
					'type' => 'user',
					'userFunc' => 'Litovchenko\AirTable\Field\BaseField->fieldErrorDisplay',
					'parameters' => [
						'message' => $arError
					]
				];
			} else {
				$fieldClass::buildConfiguration($class,$table,$field);
			}
		} else {
			$GLOBALS['TCA'][$table]['columns'][$field]['label'] = $annotationLabel;
			$GLOBALS['TCA'][$table]['columns'][$field]['config'] = [
				'type' => 'user',
				'userFunc' => 'Litovchenko\AirTable\Field\BaseField->fieldErrorDisplay',
				'parameters' => [
					'message' => [0=>'<li>Для поля задан не существующий в системе тип конфигурации <code>' . $fieldClass . '</code></li>']
				]
			];
		}
		
	}
	
	protected function registrationFieldInForm($class, $table, $field)
    {
		$annotationField 		= BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field');
		$annotationMethod 		= BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\Method'); // BaseCrud2
		$annotationPosition 	= BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\Position');
		
		// Отказался!
		// $annotationTab		= BaseUtility::getClassFieldAnnotationValueNew($class,$field,'AirTable\Field\Parameter\Tab'); // ???
		
		if(is_array($annotationPosition)){
			foreach($annotationPosition as $kA => $vA){
				$tab = current(explode(',',$vA));
				$num = end(explode(',',$vA));
				if($kA == '*' || !isset($GLOBALS['TCA'][$table]['types'][$kA])){
					\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes(
						$table, 
						$field, // implode("," , $vColumn), // что 
						'',  // структура
						'before:tab_'.$tab.'_end' // позиция after:extended
					);
				} else {
					\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes(
						$table, 
						$field, // implode("," , $vColumn), // что 
						$kA,  // структура
						'before:tab_'.$tab.'_end' // позиция after:extended
					);
				}	
			}
		} else {
			$fieldClass = 'Litovchenko\AirTable\Field\\'.$annotationField;
			if(class_exists($fieldClass) && $fieldClass::TABDEFAULT == 8) {
				$tab = 'rels';
			}else{
				$tab = 'props'; // $fieldClass::TABDEFAULT == 7
			}
			\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes(
				$table, 
				$field, // implode("," , $vColumn), // что 
				'',  // структура
				'before:tab_'.$tab.'_end' // позиция after:extended
			);
		}
	}
	
}
