<?php
namespace Litovchenko\AirTable\Utility;

class BaseUtility {

	//*********************************************
	// КЛАССЫ
	//*********************************************

	#scanClassesInFolder
	#$classLoader = \Litovchenko\AirTable\Utility\BaseUtility::getLoaderClasses();
	#$classLoader = \Litovchenko\AirTable\Utility\BaseUtility::getLoaderClassesByNamespace('Litovchenko');

    public static function getLoaderClasses($segmentFolder)
    {
		$composer = require \TYPO3\CMS\Core\Core\Environment::getPublicPath().'/vendor/autoload.php';
		if (false === empty($composer)) {
           $classes = $composer->getClassMap();
        }
		
		$allClasses = [];
		$path_Typo3Ext = \TYPO3\CMS\Core\Core\Environment::getExtensionsPath().'/'; // typo3conf/ext/
		$path_Typo3CoreExt = \TYPO3\CMS\Core\Core\Environment::getFrameworkBasePath().'/'; // typo3/sysext
		
		foreach($classes as $className => $classPath){
			$extName = $classPath;
			$extName = str_replace($path_Typo3Ext,'',$extName);
			$extName = str_replace($path_Typo3CoreExt,'',$extName);
			$extName = current(explode('/',$extName));
			if(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::isLoaded($extName)){					
				if(strstr($classPath,'/'.$segmentFolder)){
					$allClasses[] = $className;
				}
			}
		}
		
		return $allClasses;
		
		/*
		#TYPO3\CMS\Core\Core\ClassLoadingInformationGenerator
		#$classMap = \Composer\Autoload\ClassMapGenerator::createMap(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/typo3conf/ext/');
		#foreach ($contentElementsClassMap as $elementClass => $elementClassPath) {
        #    //$contentElementRegistry->registerContentElement(\TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance($elementClass));
        #}
		
		# -- рабочий вариант, но без кэша -- #
		#$classMapSysext = \Composer\Autoload\ClassMapGenerator::createMap(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/typo3/sysext/');
		#$classMapExt = \Composer\Autoload\ClassMapGenerator::createMap(\TYPO3\CMS\Core\Core\Environment::getPublicPath().'/typo3conf/ext/');
		#$classMap = array_merge($classMapSysext, $classMapExt);
		
		$path_Typo3Ext = \TYPO3\CMS\Core\Core\Environment::getExtensionsPath().'/'; // typo3conf/ext/
		$path_Typo3CoreExt = \TYPO3\CMS\Core\Core\Environment::getFrameworkBasePath().'/'; // typo3/sysext
		$extPathClassModel = array_merge(
			glob($path_Typo3Ext.'* /Classes/Domain/Model/', GLOB_ONLYDIR) // , // typo3conf/ext/
			// glob($path_Typo3CoreExt.'* /Classes/Domain/Model/', GLOB_ONLYDIR) // typo3/sysext/
		);
		
		$allClasses = [];
		foreach($extPathClassModel as $k => $v){
			$classMap = \Composer\Autoload\ClassMapGenerator::createMap($v);
			ksort($classMap);
			foreach($classMap as $className => $classPath){
				$extName = $classPath;
				$extName = str_replace($path_Typo3Ext,'',$extName);
				$extName = str_replace($path_Typo3CoreExt,'',$extName);
				$extName = current(explode('/',$extName));
				if(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::isLoaded($extName)){					
					if(strstr($classPath,'/'.$segmentFolder)){
						$allClasses[] = $className;
					}
				}
			}
		}
		
		#print "<pre>";
		#print_r($allClasses);
		#exit();
		
		return $allClasses;
		*/
    }

	/*
    public static function getLoaderClassesByNamespace($namespace)
    {
        if (0 !== strpos($namespace, '\\')) {
            $namespace = '\\' . $namespace;
        }

        $termUpper = strtoupper($namespace);
        return array_filter(self::getLoaderClasses(), function($class) use ($termUpper) {
            $className = strtoupper($class);
            if (
                0 === strpos($className, $termUpper) and
                false === strpos($className, strtoupper('Abstract')) and
                false === strpos($className, strtoupper('Interface'))
            ){
                return $class;
            }
            return false;
        });
    }
				$content = file_get_contents($phpFile->getRealPath());
				$tokens = token_get_all($content);
				$namespace = '';
				for ($index = 0; isset($tokens[$index]); $index++) {
					if (!isset($tokens[$index][0])) {
						continue;
					}
					if (T_NAMESPACE === $tokens[$index][0]) {
						$index += 2; // Skip namespace keyword and whitespace
						while (isset($tokens[$index]) && is_array($tokens[$index])) {
							$namespace .= $tokens[$index++][1];
						}
					}
					if (T_CLASS === $tokens[$index][0] && T_WHITESPACE === $tokens[$index + 1][0] && T_STRING === $tokens[$index + 2][0]) {
						$index += 2; // Skip class keyword and whitespace
						$fqcns[] = $namespace.'\\'.$tokens[$index][1];

						# break if you have one class per file (psr-4 compliant)
						# otherwise you'll need to handle class constants (Foo::class)
						break;
					}
				}
	*/

    #public static function getLoaderClassesWithTerm($term)
    #{
    #    $termUpper = strtoupper($term);
    #    return array_filter(self::getLoaderClasses(), function($class) use ($termUpper) {
    #        $className = strtoupper($class);
    #        if (
    #            false !== strpos($className, $termUpper) and
    #            false === strpos($className, strtoupper('Abstract')) and
    #            false === strpos($className, strtoupper('Interface'))
    #        ){
    #            return $class;
    #        }
    #        return false;
    #    });
    #}

	//*********************************************
	// КЛАСС (АННОТАЦИИ)
	//*********************************************

	// Получить значение аннотации класса
	public static function getClassAnnotationValueNew($class, $keyAnnotation = ''){
		// @AirTable\Label:<Таблица с примерами>
		$resAnnotations = [];
		$r = new \ReflectionClass($class);
		$doc = $r->getDocComment();
		$docLineAr = explode(chr(10),$doc);
		foreach($docLineAr as $kd => $vd){
			if(preg_match('/[@]{1}(.*):<(.*)>/is', $vd, $annotation)){
				#if(stristr($annotation[1],'AirTable\Parameter\RType\Items\\') and strstr($annotation[1],$keyAnnotation)){
				#	$annotationRealName = trim(str_ireplace('AirTable\Parameter\RType\Items\\','',$annotation[1]));
				#	$resAnnotations[] = [0=>trim($annotation[2]),1=>trim($annotationRealName)];
				#} else {
					if($annotation[1] == $keyAnnotation){
						if($keyAnnotation == 'AirTable'){
							return trim($annotation[2]);
						} else {
							$tempKeyAnnotation = 'parameterClass'.end(explode('\\',$keyAnnotation));
							// $classTableAnnotationParameters = 'Litovchenko\AirTable\AnnotationParameters\TableAnnotationParameters';
							return $class::$tempKeyAnnotation($class, $annotation[1], trim($annotation[2]));
						}
						#if($keyAnnotation == 'AirTable\Parameter\Label' && trim($annotation[2]) == '--auto--'){
						#	$table = self::getClassAnnotationValueNew($class, 'AirTable\Parameter\TableKey');
						#	if($GLOBALS['LANG']){
						#		return $GLOBALS['LANG']->sL($GLOBALS['TCA'][$table]['ctrl']['title']);
						#	} else {
						#		return $GLOBALS['TCA'][$table]['ctrl']['title'];
						#	}
						#} else {
						#	return trim($annotation[2]);
						#}
					}
				#}
			}
		}
		if(count($resAnnotations)>0){
			return $resAnnotations;
		} else {
			return '';
		}
	}
	
	// Проверить есть ли добавленный в класс треит
	public static function hasClassTrait($class, $trait = ''){
		$r = new \ReflectionClass($class);
		$traits = $r->getTraits();
		if(isset($traits[$trait])){
			return true;
		} else {
			return false;
		}
	}
	
	//*********************************************
	// ПЕРЕМЕННЫЕ КЛАССА (АННОТАЦИИ)
	//*********************************************
	
	// Получить список всех переменных
	public static function getClassAllFieldsNew($class, $keyAnnotation = ''){
		$fields = [];
		$resultFields = [];
		$resultFieldsPreSort = [];
		#if(method_exists($class,'__get_class_vars')){
		// $vars = get_class_vars($class); // Отказался из-за того, что пришлось сделать все переменные protected
		$fCount = 0;
		$vars = [];
		$reflection = new \ReflectionClass($class);
		$props = $reflection->getProperties(\ReflectionProperty::IS_PROTECTED); // IS_PRIVATE
		foreach($props as $prop){
			// @AirTable\Field:<Tab>
			// @AirTable\Field:<Input>
			if(self::getClassFieldAnnotationValueNew($class,$prop->name,'AirTable\Field') != ''){
				$userTabs = $class::baseTabs();
				$annotationPosition = BaseUtility::getClassFieldAnnotationValueNew($class,$prop->name,'AirTable\Field\Parameter\Position');
				if(is_array($annotationPosition)){
					$structure = array_key_first($annotationPosition); // Определяем по первому элементу
					$tab = current(explode(',',$annotationPosition[$structure])); // Определяем по первому элементу
					$num = end(explode(',',$annotationPosition[$structure])); // Определяем по первому элементу
				} else {
					$annotationField = BaseUtility::getClassFieldAnnotationValueNew($class,$prop->name,'AirTable\Field');
					$fieldClass = 'Litovchenko\AirTable\Field\\'.$annotationField;
					if(class_exists($fieldClass) && $fieldClass::TABDEFAULT == 8) {
						$tab = 'rels';
					}else{
						$tab = 'props'; // $fieldClass::TABDEFAULT == 7
					}
					$num = $fCount;
				}
				$fCount++;
				$tab = array_search($tab,array_keys($userTabs)); // Переводим "таб" в "№-номер"
				$resultFieldsPreSort[intval($tab)][intval($num)][] = $prop->name;
			}
		}
		
		ksort($resultFieldsPreSort);
		foreach($resultFieldsPreSort as $k => $v){
			ksort($resultFieldsPreSort[$k]);
			foreach($resultFieldsPreSort[$k] as $k2 => $v2){
				foreach($resultFieldsPreSort[$k][$k2] as $k3 => $v3){
					$resultFields[] = $v3;
				}
			}
		}
		
		#if($class == 'Litovchenko\AirTable\DefaultProperty\Model\TestDefaultFields'){
		#	print $class;
		#	print "<pre>";
		#	print_r($resultFields);
		#	exit();
		#}
		
		return $resultFields;
	}
	
	// Получить список всех переменных
	public static function getClassAllTabsNew($class, $keyAnnotation = ''){
		$fields = [];
		$resultTabs = [];
		#if(method_exists($class,'__get_class_vars')){
			// $vars = get_class_vars($class); // Отказался из-за того, что пришлось сделать все переменные protected
			$vars = [];
			$reflection = new \ReflectionClass($class);
			$props = $reflection->getProperties(\ReflectionProperty::IS_PROTECTED); // IS_PRIVATE
			foreach($props as $prop){
				$vars[] = $prop->name;
			}
			foreach($vars as $k => $v){
				// @AirTable\Tab:<1>
				if(self::getClassFieldAnnotationValueNew($class,$v,'AirTable\Tab') != ''){
					$resultTabs[] = $v;
				}
			}
		#}
		return $resultTabs;
	}
	
	// Получить значение всех аннотаций переменной в классе
	#public static function getClassFieldAnnotationsValueNew($class, $property){
	#	if(!property_exists($class,$property)){
	#		return '';
	#	}
	#	
	#	$resAnnotations = [];
	#	$r = new \ReflectionClass($class);
	#	$doc = $r->getProperty($property)->getDocComment();
	#	$docLineAr = explode(chr(10),$doc);
	#	foreach($docLineAr as $kd => $vd){
	#		if(preg_match('/[@]{1}(.*):<(.*)>/is', $vd, $annotation)){
	#			if(strstr($annotation[1],'AirTable\Field\\') && $annotation[1] != 'AirTable\Field\Parameter\Label' && $annotation[1] != 'AirTable\Field\Parameter\Description'){
	#				$annotationRealName = trim(str_ireplace('AirTable\Field\Parameter\\','',$annotation[1]));
	#				if(stristr($annotationRealName,'Items\\')){
	#					$annotationRealNameItem = trim(str_ireplace('Items\\','',$annotationRealName));
	#					$resAnnotations['Items'][$annotationRealNameItem] = trim($annotation[2]);
	#				} elseif(stristr($annotationRealName,'Arguments\\')){
	#					$annotationRealNameItem = trim(str_ireplace('Arguments\\','',$annotationRealName));
	#					$resAnnotations['Arguments'][$annotationRealNameItem] = trim($annotation[2]);
	#				} else {
	#					$resAnnotations[$annotationRealName] = trim($annotation[2]);
	#				}
	#			}
	#		}
	#	}
	#	return $resAnnotations;
	#}
	
	// Получить значение аннотации переменной в классе
	public static function getClassFieldAnnotationValueNew($class, $property, $keyAnnotation = ''){
		if(!property_exists($class,$property)){
			return '';
		}
		$resAnnotations = [];
		$r = new \ReflectionClass($class);
		$doc = $r->getProperty($property)->getDocComment();
		$docLineAr = explode(chr(10),$doc);
		foreach($docLineAr as $kd => $vd){
			if(preg_match('/[@]{1}(.*):<(.*)>/is', $vd, $annotation)){
				if($annotation[1] == $keyAnnotation or strstr($annotation[1],$keyAnnotation)){
					
					if($keyAnnotation == 'AirTable\Field'){
						return trim($annotation[2]);
					} else {
						$annotationField = self::getClassFieldAnnotationValueNew($class, $property, 'AirTable\Field');
						$fieldClass = 'Litovchenko\AirTable\Field\\'.$annotationField;
						
						if($annotation[1] == $keyAnnotation){
							$tempKeyAnnotation = 'parameter'.end(explode('\\',$keyAnnotation));
						}elseif(strstr($annotation[1],$keyAnnotation)){
							$tempKeyAnnotation = explode('\\',$keyAnnotation);
							$tempKeyAnnotation = 'parameter'.$tempKeyAnnotation[count($tempKeyAnnotation)-1];
						}
						
						// $classTableAnnotationParameters = 'Litovchenko\AirTable\AnnotationParameters\FieldAnnotationParameters';
						$result = $fieldClass::$tempKeyAnnotation($class, $property, $annotation[1], trim($annotation[2]));
						
						if(is_array($result)){
							$resAnnotations = array_merge($resAnnotations,$result);
						} else {
							return $result;
						}
						
					}
					
					#if(stristr($annotation[1],'AirTable\Field\Parameter\Items\\')){
					#	$annotationRealName = trim(str_ireplace('AirTable\Field\Parameter\Items\\','',$annotation[1]));
					#	$resAnnotations[] = [0=>trim($annotation[2]),1=>trim($annotationRealName)];
					#} elseif(stristr($annotation[1],'AirTable\Field\Parameter\Arguments\\')){
					#	$annotationRealName = trim(str_ireplace('AirTable\Field\Parameter\Arguments\\','',$annotation[1]));
					#	$resAnnotations[trim($annotationRealName)] = trim($annotation[2]);
					#} elseif(stristr($annotation[1],'AirTable\Field\Parameter\Position\\')){
					#	$annotationRealName = trim(str_ireplace('AirTable\Field\Parameter\Position\\','',$annotation[1]));
					#	$resAnnotations[trim($annotationRealName)] = trim($annotation[2]);
					#} else {
					#	if($annotation[1] == 'AirTable\Field\Parameter\ForeignModel' && trim($annotation[2]) == 'current'){
					#		return $class;
					#	} elseif($annotation[1] == 'AirTable\Field\Parameter\ForeignModel' && trim($annotation[2]) == 'category'){
					#		return $class.'Category';
					#	} else {
					#		return trim($annotation[2]);
					#	}
					#}
				}
			}
		}
		if(count($resAnnotations)>0){
			return $resAnnotations;
		} else {
			return '';
		}
	}

	//*********************************************
	// ДРУГОЕ
	//*********************************************
	
	// Получить список всех моделей которые имеют ссылки на данныю модель
	#public static function getForeignFieldsByClass($class){
	#	$foreignFields = [];
	#	$models = get_declared_classes();
	#	foreach($models as $model) {
	#		$class_parents = class_parents($model);
	#		if(in_array('Litovchenko\AirTable\Model\BaseCrud',$class_parents)){
	#			$fields = BaseUtility::getClassAllFieldsNew($model);
	#			foreach ($fields as $field){
	#				$config = BaseUtility::getClassFieldAnnotationValueNew($model,$field,'AirTable\Field');
	#				$foreignModel = BaseUtility::getClassFieldAnnotationValueNew($model,$field,'AirTable\Field\Parameter\ForeignModel');
	#				if($foreignModel == $class && $model != $class){ // && "$model != $class" ->пропускаем связи на себя
	#					$foreignKey = BaseUtility::getClassFieldAnnotationValueNew($model,$field,'AirTable\Field\Parameter\ForeignKey');
	#					$foreignFields[] = [
	#						'fieldClass' => $config.'_Revers', // AirTable\Field
	#						'foreignModel' => $model, // AirTable\Field\Parameter\ForeignModel
	#						'foreignKey' => $foreignKey // AirTable\Field\Parameter\ForeignKey
	#					];
	#				}
	#			}
	#		}
	#	}
	#	return $foreignFields;
	#}
	
	// Получить путь к классу
	public static function getClassPath($class){
		$r = new \ReflectionClass($class);
		return $r->getFileName();
	}
	
	// Получить путь к классу (только папка)
	public static function getClassDirPath($class){
		$r = new \ReflectionClass($class);
		$segments = explode('/',$r->getFileName());
		unset($segments[count($segments)-1]);
		return implode('/',$segments).'/';
	}
	
	// Получить название расширения из пути класса
	public static function getExtNameFromClassPath($class){
		$r = new \ReflectionClass($class);
		$fPath = $r->getFileName();
		$temp = explode('Classes/',$fPath);
		$temp = explode('/',$temp[0]);
		$extName = $temp[count($temp)-2];
		return $extName;
	}
	
	// Получить название папки (подмодели) из пути класса
	public static function getSubDomainNameFromClassPath($class){
		$r = new \ReflectionClass($class);
		$fPath = $r->getFileName();
		$temp = explode('Classes/Domain/Model/',$fPath);
		$temp = explode('/',$temp[1]);
		if(count($temp) > 1){
			$subDomain = $temp[0];
		} else {
			$subDomain = 'Root';
		}
		return $subDomain;
	}
	
	// Получить значение из _GET, либо установить по умолчанию с сохранением в BE_USER->UC
	public static function _GETuc($key = '', $default = '', $firstKey = ''){
		if($firstKey == ''){
			$firstKey = $GLOBALS['_GET']['route'].'_GET';
		}
		$firstKey = md5($firstKey);
		
		if(isset($GLOBALS['_GET'][$key])) {
			$GLOBALS['BE_USER']->uc['air_table']['_GETuc'][$firstKey][$key] = $GLOBALS['_GET'][$key];
			$GLOBALS['BE_USER']->writeUC();
			$val = $GLOBALS['_GET'][$key];
			
		} elseif ($GLOBALS['BE_USER']->uc['air_table']['_GETuc'][$firstKey][$key] != '') {
			$val = $GLOBALS['BE_USER']->uc['air_table']['_GETuc'][$firstKey][$key];
			
		} else {
			$val = $default;
			
		}
		
		// Fix bug - после удаления расширения, будет ошибка если была
		// открыта папка с таблицами удаленного расширения, которые были записаны в "$GLOBALS['BE_USER']->uc"
		if($key == 'paramExt'){
			// use TYPO3\CMS\Core\Utility\ExtensionManagementUtility;
			if(!\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::isLoaded($val)){
				return $default;
			}
		}
		
		return $val;
	}

	// Получить значение из _POST, либо установить по умолчанию с сохранением в BE_USER->UC
	// $dependency -> это зависимое значение формы, по которому определяется отправлена ли она?
	public static function _POSTuc($dependency = false, $key = '', $default = ''){
		
		// Зависимость от другого параметра
		if($dependency == false){
			return null;
		}
		
		// Базовый маршрут
		// $firstKey = $GLOBALS['_GET']['route'].'_POST';
		$firstKey  = '';
		$firstKey .= $GLOBALS['_GET']['paramClass'];
		$firstKey .= $GLOBALS['_GET']['recordSelection']; // Если делается выбор
		$firstKey .= $GLOBALS['_GET']['recordSelectionFieldname']; // Если делается выбор
		$firstKey = md5($firstKey);
		
		#if($dependency == 'form0Apply'){
		#	print "<pre>";
		#	print_r($GLOBALS['_POST']);
		#	print "</pre>";
		#}
		
		/////////////////////////////////////////////////////////////////////
		// Новый вариант (с исправленным багом)
		/////////////////////////////////////////////////////////////////////
		if($GLOBALS['_POST'][$dependency] == 1) {
			$GLOBALS['BE_USER']->uc['air_table']['_POSTuc'][$firstKey][$key] = $GLOBALS['_POST'][$key];
			$GLOBALS['BE_USER']->writeUC();
			return $GLOBALS['_POST'][$key];
			
		} elseif($GLOBALS['_POST'][$dependency] == -1) {
			$GLOBALS['BE_USER']->uc['air_table']['_POSTuc'][$firstKey][$key] = [];
			$GLOBALS['BE_USER']->writeUC();
			return $default;
			
		} elseif ($GLOBALS['BE_USER']->uc['air_table']['_POSTuc'][$firstKey][$dependency] == 1) {
			return $GLOBALS['BE_USER']->uc['air_table']['_POSTuc'][$firstKey][$key];
			
		} else {
			return $default;
			
		}
	}
	
	// Сгенерировать название таблицы из модели
	public static function getTableNameFromClass($class, $short = 0){
		if(class_exists($class)){
			
			// Если принудительно установлен ключ таблицы
			if(self::getClassAnnotationValueNew($class,'AirTable\Parameter\TableKey') != ''){
				$table = self::getClassAnnotationValueNew($class,'AirTable\Parameter\TableKey');
			
			// По умолчанию используем DataMap
			} else {
			
				// Если требуется сокращенный вариант
				if($short == 1){
					return strtolower(self::getClassNameWithoutNamespace($class));
				}	
			
				if(self::isModelCategoryForAnotherModel($class)){
					#$objectManager = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Extbase\Object\ObjectManager::class);
					#$dataMapper = $objectManager->get(\TYPO3\CMS\Extbase\Persistence\Generic\Mapper\DataMapper::class);
					#$table = $dataMapper->getDataMap($class)->getTableName();
					#$table = preg_replace('/category$/is','_category',$table); // добавляем _category префикс для категорий
					if(self::getSubDomainNameFromClassPath($class) == ''){
						$table = strtolower(
							'tx_'.
							self::getExtNameFromClassPath($class).'_'.
							self::getClassNameWithoutNamespace($class)
						);
					} else {
						$table = strtolower(
							'tx_'.
							self::getExtNameFromClassPath($class).'_'.
							self::getSubDomainNameFromClassPath($class).'_'.
							self::getClassNameWithoutNamespace($class)
						);
					}
					$table = preg_replace('/category$/is','_category',$table); // меняем "_category" постфикс для категорий
				} else {
					#$objectManager = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Extbase\Object\ObjectManager::class);
					#$dataMapper = $objectManager->get(\TYPO3\CMS\Extbase\Persistence\Generic\Mapper\DataMapper::class);
					#$table = $dataMapper->getDataMap($class)->getTableName();
					if(self::getSubDomainNameFromClassPath($class) == ''){
						$table = strtolower(
							'tx_'.
							self::getExtNameFromClassPath($class).'_'.
							self::getClassNameWithoutNamespace($class)
						);
					} else {
						$table = strtolower(
							'tx_'.
							self::getExtNameFromClassPath($class).'_'.
							self::getSubDomainNameFromClassPath($class).'_'.
							self::getClassNameWithoutNamespace($class)
						);
					}
				}
			}
						
			return $table;
		}
		return null;
	}
	
	// Получить название класса без Namespace
	public static function getClassNameWithoutNamespace($class){
		return end(explode('\\',$class));
	}

	// Функция првоеряет является ли модель категорией (категоризация)
	public static function isModelCategoryForAnotherModel($class = ''){
		$modelWithoutPostfixCategory = preg_replace('/(.*?)Category$/s', '\\1', $class);
		if(preg_match('/(.*?)Category$/s',$class) && class_exists($modelWithoutPostfixCategory)){
			return true;
		}
		return false;
	}
	
	// Функция проверяет может ли запись модели состоять в одной категории (категоризация)
	public static function isModelSupportOneCategory($class = ''){
		$modelWithCategory = $class.'Category';
		if(!preg_match('/(.*?)Category$/s', $class) && class_exists($modelWithCategory)){
			if(self::hasClassTrait($class,'Litovchenko\AirTable\Field\Traits\CategoryId') == true){
				return true;
			}
			#$a = new \ReflectionClass($modelWithCategory);
			#$file_name = basename($a->getFileName());
			#if(!preg_match('/(.*?).mm.php$/s', $file_name)){
			#	return true;
			#}
		}
		return false;
	}

	// Функция проверяет может ли запись модели состоять в нескольких категориях (категоризация)
	public static function isModelSupportManyCategories($class = ''){
		$modelWithCategory = $class.'Category';
		if(!preg_match('/(.*?)Category$/s', $class) && class_exists($modelWithCategory)){
			if(self::hasClassTrait($class,'Litovchenko\AirTable\Field\Traits\CategoryMany') == true){
				return true;
			}
			#$a = new \ReflectionClass($modelWithCategory);
			#$file_name = basename($a->getFileName());
			#if(preg_match('/(.*?).mm.php$/s', $file_name)){
			#	return true;
			#}
		}
		return false;
	}

	// Функция получает список всех колонок, которые есть в структуре
	public static function getAllColumnsFromType($table, $type){
		$fields = [];
		#$table = 'pages';
		#$type = 1;
		$list = $GLOBALS['TCA'][$table]['types'][$type]['showitem'];
		$list = explode(',', $list);
		foreach($list as $k => $v){
			$temp = explode(';',$v);
			switch(trim($temp[0])){
				case '--div--': 
					continue;
				break;
				case '--palette--':
					// [0] --palette--
					// [1] LLL:EXT:frontend/Resources/Private/Language/locallang_tca.xlf:pages.palettes.visibility
					// [2] visibility
					$tempPalette = explode(',',$GLOBALS['TCA'][$table]['palettes'][$temp[2]]['showitem']);
					foreach($tempPalette as $kPalette => $vPalette){
						$temp2 = explode(';',$vPalette);
						if(trim($temp2[0]) != '--linebreak--'){
							if(trim($temp2[0]) != null){
								$fields[] = trim($temp2[0]);
							}
						}
					}
				break;
				default:
					if(preg_match('/tab_(.*)_start/is',trim($temp[0]))){
						continue;
					}
					if(preg_match('/tab_(.*)_end/is',trim($temp[0]))){
						continue;
					}
					if(trim($temp[0]) != null){
						$fields[] = trim($temp[0]);
					}
				break;
			}
		}
		//LLL:EXT:frontend/Resources/Private/Language/locallang_tca.xlf:pages.editlock_formlabel ???
		// print "<pre>";
		// print_r($fields);
		// exit();
		return $fields;
	}
	
	// Функция создает (либо перезаписывае) содержимое файла
	public static function fileReWrite($path, $content){
		if($path != null){
			$handleConstant = fopen($path, 'w+');
			fwrite($handleConstant, $content);
			fclose($handleConstant);
		}
	}
	
	// Функция создает (либо перезаписывае) содержимое файла
	public static function fileWrite($path, $content){
		if($path != null){
			$handleConstant = fopen($path, 'a+');
			fwrite($handleConstant, $content);
			fclose($handleConstant);
		}
	}
	
	// Получить значение Item
	public static function getTcaFieldItem($table, $field, $item){
		foreach($GLOBALS['TCA'][$table]['columns'][$field]['config']['items'] as $k => $i){
			if($i[1] == $item){
				return $i;
			}
		}
	}
	
	// Функции доступа
	// https://docs.typo3.org/m/typo3/reference-coreapi/master/en-us/ApiOverview/BackendUserObject/Index.html
	// $calcPerms = $backendUser->calcPerms(BackendUtility::readPageAccess($rec['pid'], $backendUser->getPagePermsClause(Permission::PAGE_SHOW)));
	// $localCalcPerms = $backendUser->calcPerms(BackendUtility::getRecord('pages', $rec['uid']));
	// $backendUser->check('non_exclude_fields', $foreignTable . ':' . $hiddenField));

	public static function BeUserAccessTableSelect($table = 'tt_content'){
		return $GLOBALS['BE_USER']->check('tables_select', $table);
	}
	
	public static function BeUserAccessTableModify($table = 'tt_content'){
		return $GLOBALS['BE_USER']->check('tables_modify', $table);
	}
	
	public static function BeUserAccessModule($module = 'web_list'){
		return $GLOBALS['BE_USER']->check('modules', $module);
	}
	
	// Функция вывода Дебага
	public static function debugInController(){
		// https://somethingphp.com/debugging-typo3/
		#\TYPO3\CMS\Core\Utility\DebugUtility::debug('VAR','HEADER','Debug');
		#\TYPO3\CMS\Extbase\Utility\DebuggerUtility::var_dump(array(1=>432));
		#\TYPO3\CMS\Extbase\Utility\DebuggerUtility::var_dump('VAR', 'FormObject:');
		
		#try {
			ob_start();
				require \TYPO3\CMS\Core\Core\Environment::getPublicPath().'/typo3conf/Debug.php';
				$content = ob_get_contents();
			ob_end_clean();
			
			#\TYPO3\CMS\Extbase\Utility\DebuggerUtility::var_dump($content,'1df');
		#} catch (Exception $e) {
		#
		#}
		
		if(!empty($content)){
			return 'typo3conf/Debug.php:<br />'.$content;
		} else {
			return '';
		}
	}
	
	// Функция получения информации из TCA-массива
	// Todo
	public static function TCAvalue($table, $type = 'label'){
		switch($type){
			case 'label':
				return $GLOBALS['TCA'][$table]['ctrl']['label'];
			break;
		}
	}

}
?>